/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/
(function(){var e=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/base/common/errors","vs/base/common/cancellation","vs/base/common/types","vs/base/common/objects","vs/base/common/functional","vs/base/common/uri","vs/base/common/async","vs/base/common/paths","vs/base/node/console","vs/base/common/linkedList","vs/base/common/iterator","vs/base/common/amd","vs/base/common/strings","vs/base/node/decoder","vs/platform/telemetry/node/telemetryIpc","vs/base/parts/ipc/node/ipc","vs/nls!vs/base/node/processes","vs/platform/telemetry/node/appInsightsAppender","vs/platform/log/common/log","vs/base/node/processes","vs/platform/instantiation/common/instantiation","vs/base/parts/ipc/node/ipc.cp","child_process","fs","path","vs/nls!vs/workbench/parts/debug/node/telemetryApp","vs/nls","applicationinsights","string_decoder","vs/workbench/parts/debug/node/telemetryApp"],t=function(t){for(var n=[],r=0,i=t.length;r<i;r++)n[r]=e[t[r]];return n}
;define(e[5],t([0,1]),function(e,t){"use strict";function n(e){return e instanceof Error&&e.name===i&&e.message===i}Object.defineProperty(t,"__esModule",{value:!0});var r=function(){function e(){this.listeners=[],this.unexpectedErrorHandler=function(e){setTimeout(function(){if(e.stack)throw new Error(e.message+"\n\n"+e.stack);throw e},0)}}return e.prototype.addListener=function(e){var t=this;return this.listeners.push(e),function(){t._removeListener(e)}},e.prototype.emit=function(e){this.listeners.forEach(function(t){t(e)})},e.prototype._removeListener=function(e){this.listeners.splice(this.listeners.indexOf(e),1)},e.prototype.setUnexpectedErrorHandler=function(e){this.unexpectedErrorHandler=e},e.prototype.getUnexpectedErrorHandler=function(){return this.unexpectedErrorHandler},e.prototype.onUnexpectedError=function(e){this.unexpectedErrorHandler(e),this.emit(e)},e.prototype.onUnexpectedExternalError=function(e){this.unexpectedErrorHandler(e)},e}();t.ErrorHandler=r,t.errorHandler=new r,
t.setUnexpectedErrorHandler=function(e){t.errorHandler.setUnexpectedErrorHandler(e)},t.onUnexpectedError=function(e){n(e)||t.errorHandler.onUnexpectedError(e)},t.onUnexpectedExternalError=function(e){n(e)||t.errorHandler.onUnexpectedExternalError(e)},t.transformErrorForSerialization=function(e){if(e instanceof Error)return{$isError:!0,name:e.name,message:e.message,stack:e.stacktrace||e.stack};return e};var i="Canceled";t.isPromiseCanceledError=n,t.canceled=function(){var e=new Error(i);return e.name=e.message,e},t.illegalArgument=function(e){return e?new Error("Illegal argument: "+e):new Error("Illegal argument")},t.illegalState=function(e){return e?new Error("Illegal state: "+e):new Error("Illegal state")},t.readonly=function(e){return e?new Error("readonly property '"+e+" cannot be changed'"):new Error("readonly property cannot be changed")},t.disposed=function(e){var t=new Error(e+" has been disposed");return t.name="DISPOSED",t},t.getErrorMessage=function(e){
return e?e.message?e.message:e.stack?e.stack.split("\n")[0]:String(e):"Error"}}),define(e[9],t([0,1]),function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.once=function(e){var t,n=this,r=!1;return function(){return r?t:(r=!0,t=e.apply(n,arguments))}}});var n=this&&this.__extends||function(){var e=function(t,n){return(e=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var n in t)t.hasOwnProperty(n)&&(e[n]=t[n])})(t,n)};return function(t,n){function r(){this.constructor=t}e(t,n),t.prototype=null===n?Object.create(n):(r.prototype=n.prototype,new r)}}();define(e[15],t([0,1]),function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FIN={done:!0,value:void 0};var r;!function(e){function n(e,t){for(var n=e.next();!n.done;n=e.next())t(n.value)}var r={next:function(){return t.FIN}};e.empty=function(){return r},e.fromArray=function(e,n,r){return void 0===n&&(n=0),void 0===r&&(r=e.length),{next:function(){
return n>=r?t.FIN:{done:!1,value:e[n++]}}}},e.from=function(t){return t?Array.isArray(t)?e.fromArray(t):t:e.empty()},e.map=function(e,n){return{next:function(){var r=e.next();return r.done?t.FIN:{done:!1,value:n(r.value)}}}},e.filter=function(e,n){return{next:function(){for(;;){var r=e.next();if(r.done)return t.FIN;if(n(r.value))return{done:!1,value:r.value}}}}},e.forEach=n,e.collect=function(e){var t=[];return n(e,function(e){return t.push(e)}),t}}(r=t.Iterator||(t.Iterator={})),t.getSequenceIterator=function(e){return Array.isArray(e)?r.fromArray(e):e};var i=function(){function e(e,t,n,r){void 0===t&&(t=0),void 0===n&&(n=e.length),void 0===r&&(r=t-1),this.items=e,this.start=t,this.end=n,this.index=r}return e.prototype.first=function(){return this.index=this.start,this.current()},e.prototype.next=function(){return this.index=Math.min(this.index+1,this.end),this.current()},e.prototype.current=function(){return this.index===this.start-1||this.index===this.end?null:this.items[this.index]},e}();t.ArrayIterator=i
;var o=function(e){function t(t,n,r,i){return void 0===n&&(n=0),void 0===r&&(r=t.length),void 0===i&&(i=n-1),e.call(this,t,n,r,i)||this}return n(t,e),t.prototype.current=function(){return e.prototype.current.call(this)},t.prototype.previous=function(){return this.index=Math.max(this.index-1,this.start-1),this.current()},t.prototype.first=function(){return this.index=this.start,this.current()},t.prototype.last=function(){return this.index=this.end-1,this.current()},t.prototype.parent=function(){return null},t}(i);t.ArrayNavigator=o;var s=function(){function e(e,t){this.iterator=e,this.fn=t}return e.prototype.next=function(){return this.fn(this.iterator.next())},e}();t.MappedIterator=s;var u=function(e){function t(t,n){var r=e.call(this,t,n)||this;return r.navigator=t,r}return n(t,e),t.prototype.current=function(){return this.fn(this.navigator.current())},t.prototype.previous=function(){return this.fn(this.navigator.previous())},t.prototype.parent=function(){return this.fn(this.navigator.parent())},
t.prototype.first=function(){return this.fn(this.navigator.first())},t.prototype.last=function(){return this.fn(this.navigator.last())},t.prototype.next=function(){return this.fn(this.navigator.next())},t}(s);t.MappedNavigator=u}),define(e[2],t([0,1,9]),function(e,t,n){"use strict";function r(e){for(var t=[],n=1;n<arguments.length;n++)t[n-1]=arguments[n];return Array.isArray(e)?(e.forEach(function(e){return e&&e.dispose()}),[]):0!==t.length?(r(e),r(t),[]):e?(e.dispose(),e):void 0}Object.defineProperty(t,"__esModule",{value:!0}),t.isDisposable=function(e){return"function"==typeof e.dispose&&0===e.dispose.length},t.dispose=r,t.combinedDisposable=function(e){return{dispose:function(){return r(e)}}},t.toDisposable=function(e){return{dispose:function(){e()}}};var i=function(){function e(){this._toDispose=[],this._lifecycle_disposable_isDisposed=!1}return Object.defineProperty(e.prototype,"toDispose",{get:function(){return this._toDispose},enumerable:!0,configurable:!0}),e.prototype.dispose=function(){
this._lifecycle_disposable_isDisposed=!0,this._toDispose=r(this._toDispose)},e.prototype._register=function(e){return this._lifecycle_disposable_isDisposed?(console.warn("Registering disposable on object that has already been disposed."),e.dispose()):this._toDispose.push(e),e},e.None=Object.freeze({dispose:function(){}}),e}();t.Disposable=i;var o=function(){function e(){this.references=Object.create(null)}return e.prototype.acquire=function(e){var t=this,r=this.references[e];r||(r=this.references[e]={counter:0,object:this.createReferencedObject(e)});var i=r.object,o=n.once(function(){0==--r.counter&&(t.destroyReferencedObject(e,r.object),delete t.references[e])});return r.counter++,{object:i,dispose:o}},e}();t.ReferenceCollection=o;var s=function(){function e(e){this.object=e}return e.prototype.dispose=function(){},e}();t.ImmortalReference=s}),define(e[14],t([0,1,15]),function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var r=function(){return function(e){this.element=e}
}(),i=function(){function e(){this._size=0}return Object.defineProperty(e.prototype,"size",{get:function(){return this._size},enumerable:!0,configurable:!0}),e.prototype.isEmpty=function(){return!this._first},e.prototype.clear=function(){this._first=void 0,this._last=void 0,this._size=0},e.prototype.unshift=function(e){return this._insert(e,!1)},e.prototype.push=function(e){return this._insert(e,!0)},e.prototype._insert=function(e,t){var n=new r(e);if(this._first)if(t){var i=this._last;this._last=n,n.prev=i,i.next=n}else{var o=this._first;this._first=n,n.next=o,o.prev=n}else this._first=n,this._last=n;return this._size+=1,this._remove.bind(this,n)},e.prototype.shift=function(){if(this._first){var e=this._first.element;return this._remove(this._first),e}},e.prototype.pop=function(){if(this._last){var e=this._last.element;return this._remove(this._last),e}},e.prototype._remove=function(e){for(var t=this._first;t instanceof r;){if(t===e){if(t.prev&&t.next){var n=t.prev;n.next=t.next,t.next.prev=n
}else t.prev||t.next?t.next?t.prev||(this._first=this._first.next,this._first.prev=void 0):(this._last=this._last.prev,this._last.next=void 0):(this._first=void 0,this._last=void 0);this._size-=1;break}t=t.next}},e.prototype.iterator=function(){var e,t=this._first;return{next:function(){return t?(e?e.value=t.element:e={done:!1,value:t.element},t=t.next,e):n.FIN}}},e.prototype.toArray=function(){for(var e=[],t=this._first;t instanceof r;t=t.next)e.push(t.element);return e},e}();t.LinkedList=i});var r=this&&this.__awaiter||function(e,t,n,r){return new(n||(n=Promise))(function(i,o){function s(e){try{c(r.next(e))}catch(e){o(e)}}function u(e){try{c(r.throw(e))}catch(e){o(e)}}function c(e){e.done?i(e.value):new n(function(t){t(e.value)}).then(s,u)}c((r=r.apply(e,t||[])).next())})},i=this&&this.__generator||function(e,t){function n(n){return function(s){return function(n){if(r)throw new TypeError("Generator is already executing.");for(;u;)try{if(r=1,i&&(o=2&n[0]?i.return:n[0]?i.throw||((o=i.return)&&o.call(i),
0):i.next)&&!(o=o.call(i,n[1])).done)return o;switch(i=0,o&&(n=[2&n[0],o.value]),n[0]){case 0:case 1:o=n;break;case 4:return u.label++,{value:n[1],done:!1};case 5:u.label++,i=n[1],n=[0];continue;case 7:n=u.ops.pop(),u.trys.pop();continue;default:if(o=u.trys,!(o=o.length>0&&o[o.length-1])&&(6===n[0]||2===n[0])){u=0;continue}if(3===n[0]&&(!o||n[1]>o[0]&&n[1]<o[3])){u.label=n[1];break}if(6===n[0]&&u.label<o[1]){u.label=o[1],o=n;break}if(o&&u.label<o[2]){u.label=o[2],u.ops.push(n);break}o[2]&&u.ops.pop(),u.trys.pop();continue}n=t.call(e,u)}catch(e){n=[6,e],i=0}finally{r=o=0}if(5&n[0])throw n[1];return{value:n[0]?n[1]:void 0,done:!0}}([n,s])}}var r,i,o,s,u={label:0,sent:function(){if(1&o[0])throw o[1];return o[1]},trys:[],ops:[]};return s={next:n(0),throw:n(1),return:n(2)},"function"==typeof Symbol&&(s[Symbol.iterator]=function(){return this}),s};define(e[3],t([0,1,5,9,2,14]),function(e,t,o,s,u,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var a;!function(e){function t(e){return function(t,n,r){
void 0===n&&(n=null);var i=!1,o=e(function(e){if(!i)return o?o.dispose():i=!0,t.call(n,e)},null,r);return i&&o.dispose(),o}}function n(e,t){return function(n,r,i){return void 0===r&&(r=null),e(function(e){return n.call(r,t(e))},null,i)}}function r(e,t){return function(n,r,i){return void 0===r&&(r=null),e(function(e){t(e),n.call(r,e)},null,i)}}function i(e,t){return function(n,r,i){return void 0===r&&(r=null),e(function(e){return t(e)&&n.call(r,e)},null,i)}}function o(e,t,r){var i=r;return n(e,function(e){return i=t(i,e)})}function s(e){var t,n=!0;return i(e,function(e){var r=n||e!==t;return n=!1,t=e,r})}var c={dispose:function(){}};e.None=function(){return c},e.once=t,e.map=n,e.forEach=r,e.filter=i,e.signal=function(e){return e},e.any=function(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];return function(t,n,r){return void 0===n&&(n=null),u.combinedDisposable(e.map(function(e){return e(function(e){return t.call(n,e)},null,r)}))}},e.reduce=o,e.debounce=function(e,t,n,r,i){void 0===n&&(n=100),
void 0===r&&(r=!1);var o,s=void 0,u=void 0,c=0,a=new h({leakWarningThreshold:i,onFirstListenerAdd:function(){o=e(function(e){c++,s=t(s,e),r&&!u&&a.fire(s),clearTimeout(u),u=setTimeout(function(){var e=s;s=void 0,u=void 0,(!r||c>1)&&a.fire(e),c=0},n)})},onLastListenerRemove:function(){o.dispose()}});return a.event},e.stopwatch=function(e){var r=(new Date).getTime();return n(t(e),function(e){return(new Date).getTime()-r})},e.latch=s,e.buffer=function(e,t,n){void 0===t&&(t=!1),void 0===n&&(n=[]);var r=n.slice(),i=e(function(e){r?r.push(e):s.fire(e)}),o=function(){r&&r.forEach(function(e){return s.fire(e)}),r=null},s=new h({onFirstListenerAdd:function(){i||(i=e(function(e){return s.fire(e)}))},onFirstListenerDidAdd:function(){r&&(t?setTimeout(o):o())},onLastListenerRemove:function(){i&&i.dispose(),i=null}});return s.event},e.echo=function(e,t,n){void 0===t&&(t=!1),void 0===n&&(n=[]),n=n.slice(),e(function(e){n.push(e),i.fire(e)});var r=function(e,t){return n.forEach(function(n){return e.call(t,n)})},i=new h({
onListenerDidAdd:function(e,n,i){t?setTimeout(function(){return r(n,i)}):r(n,i)}});return i.event};var a=function(){function e(e){this._event=e}return Object.defineProperty(e.prototype,"event",{get:function(){return this._event},enumerable:!0,configurable:!0}),e.prototype.map=function(t){return new e(n(this._event,t))},e.prototype.forEach=function(t){return new e(r(this._event,t))},e.prototype.filter=function(t){return new e(i(this._event,t))},e.prototype.reduce=function(t,n){return new e(o(this._event,t,n))},e.prototype.latch=function(){return new e(s(this._event))},e.prototype.on=function(e,t,n){return this._event(e,t,n)},e.prototype.once=function(e,n,r){return t(this._event)(e,n,r)},e}();e.chain=function(e){return new a(e)},e.fromNodeEventEmitter=function(e,t,n){void 0===n&&(n=function(e){return e});var r=function(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];return i.fire(n.apply(void 0,e))},i=new h({onFirstListenerAdd:function(){return e.on(t,r)},onLastListenerRemove:function(){
return e.removeListener(t,r)}});return i.event},e.fromPromise=function(e){var t=new h,n=!1;return e.then(void 0,function(){return null}).then(function(){n?t.fire(void 0):setTimeout(function(){return t.fire(void 0)},0)}),n=!0,t.event},e.toPromise=function(e){return new Promise(function(n){return t(e)(n)})}}(a=t.Event||(t.Event={}));var l=-1;t.setGlobalLeakWarningThreshold=function(e){var t=l;return l=e,{dispose:function(){l=t}}};var f=function(){function e(e,t){void 0===t&&(t=Math.random().toString(18).slice(2,5)),this.customThreshold=e,this.name=t,this._warnCountdown=0}return e.prototype.dispose=function(){this._stacks&&this._stacks.clear()},e.prototype.check=function(e){var t=this,n=l;if("number"==typeof this.customThreshold&&(n=this.customThreshold),!(n<=0||e<n)){this._stacks||(this._stacks=new Map);var r=(new Error).stack.split("\n").slice(3).join("\n"),i=this._stacks.get(r)||0;if(this._stacks.set(r,i+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=.5*n;var o,s=0
;this._stacks.forEach(function(e,t){(!o||s<e)&&(o=t,s=e)}),console.warn("["+this.name+"] potential listener LEAK detected, having "+e+" listeners already. MOST frequent listener ("+s+"):"),console.warn(o)}return function(){var e=t._stacks.get(r)||0;t._stacks.set(r,e-1)}}},e}(),h=function(){function e(e){this._disposed=!1,this._options=e,this._leakageMon=l>0?new f(this._options&&this._options.leakWarningThreshold):void 0}return Object.defineProperty(e.prototype,"event",{get:function(){var t=this;return this._event||(this._event=function(n,r,i){t._listeners||(t._listeners=new c.LinkedList);var o=t._listeners.isEmpty();o&&t._options&&t._options.onFirstListenerAdd&&t._options.onFirstListenerAdd(t);var s=t._listeners.push(r?[n,r]:n);o&&t._options&&t._options.onFirstListenerDidAdd&&t._options.onFirstListenerDidAdd(t),t._options&&t._options.onListenerDidAdd&&t._options.onListenerDidAdd(t,n,r);var u;t._leakageMon&&(u=t._leakageMon.check(t._listeners.size));var a;return a={dispose:function(){if(u&&u(),
a.dispose=e._noop,!t._disposed&&(s(),t._options&&t._options.onLastListenerRemove)){t._listeners&&!t._listeners.isEmpty()||t._options.onLastListenerRemove(t)}}},Array.isArray(i)&&i.push(a),a}),this._event},enumerable:!0,configurable:!0}),e.prototype.fire=function(e){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=[]);for(var t=this._listeners.iterator(),n=t.next();!n.done;n=t.next())this._deliveryQueue.push([n.value,e]);for(;this._deliveryQueue.length>0;){var r=this._deliveryQueue.shift(),i=r[0],s=r[1];try{"function"==typeof i?i.call(void 0,s):i[0].call(i[1],s)}catch(n){o.onUnexpectedError(n)}}}},e.prototype.dispose=function(){this._listeners&&(this._listeners=void 0),this._deliveryQueue&&(this._deliveryQueue.length=0),this._leakageMon&&this._leakageMon.dispose(),this._disposed=!0},e._noop=function(){},e}();t.Emitter=h;var p=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return n(t,e),t.prototype.fireAsync=function(e){return r(this,void 0,void 0,function(){var t,n,r,s,u,c
;return i(this,function(i){switch(i.label){case 0:if(!this._listeners)return[2];for(this._asyncDeliveryQueue||(this._asyncDeliveryQueue=[]),t=this._listeners.iterator(),n=t.next();!n.done;n=t.next())c=[],this._asyncDeliveryQueue.push([n.value,e(c,"function"==typeof n.value?n.value:n.value[0]),c]);i.label=1;case 1:if(!(this._asyncDeliveryQueue.length>0))return[3,3];r=this._asyncDeliveryQueue.shift(),s=r[0],u=r[1],c=r[2];try{"function"==typeof s?s.call(void 0,u):s[0].call(s[1],u)}catch(e){return o.onUnexpectedError(e),[3,1]}return Object.freeze(c),[4,Promise.all(c)];case 2:return i.sent(),[3,1];case 3:return[2]}})})},t}(h);t.AsyncEmitter=p;var d=function(){function e(){var e=this;this.hasListeners=!1,this.events=[],this.emitter=new h({onFirstListenerAdd:function(){return e.onFirstListenerAdd()},onLastListenerRemove:function(){return e.onLastListenerRemove()}})}return Object.defineProperty(e.prototype,"event",{get:function(){return this.emitter.event},enumerable:!0,configurable:!0}),e.prototype.add=function(e){
var t=this,n={event:e,listener:null};this.events.push(n),this.hasListeners&&this.hook(n);return u.toDisposable(s.once(function(){t.hasListeners&&t.unhook(n);var e=t.events.indexOf(n);t.events.splice(e,1)}))},e.prototype.onFirstListenerAdd=function(){var e=this;this.hasListeners=!0,this.events.forEach(function(t){return e.hook(t)})},e.prototype.onLastListenerRemove=function(){var e=this;this.hasListeners=!1,this.events.forEach(function(t){return e.unhook(t)})},e.prototype.hook=function(e){var t=this;e.listener=e.event(function(e){return t.emitter.fire(e)})},e.prototype.unhook=function(e){e.listener&&e.listener.dispose(),e.listener=null},e.prototype.dispose=function(){this.emitter.dispose()},e}();t.EventMultiplexer=d;var v=function(){function e(){this.buffers=[]}return e.prototype.wrapEvent=function(e){var t=this;return function(n,r,i){return e(function(e){var i=t.buffers[t.buffers.length-1];i?i.push(function(){return n.call(r,e)}):n.call(r,e)},void 0,i)}},e.prototype.bufferEvents=function(e){var t=[]
;this.buffers.push(t);var n=e();return this.buffers.pop(),t.forEach(function(e){return e()}),n},e}();t.EventBufferer=v;var g=function(){function e(){var e=this;this.listening=!1,this.inputEvent=a.None,this.inputEventListener=u.Disposable.None,this.emitter=new h({onFirstListenerDidAdd:function(){e.listening=!0,e.inputEventListener=e.inputEvent(e.emitter.fire,e.emitter)},onLastListenerRemove:function(){e.listening=!1,e.inputEventListener.dispose()}}),this.event=this.emitter.event}return Object.defineProperty(e.prototype,"input",{set:function(e){this.inputEvent=e,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=e(this.emitter.fire,this.emitter))},enumerable:!0,configurable:!0}),e.prototype.dispose=function(){this.inputEventListener.dispose(),this.emitter.dispose()},e}();t.Relay=g}),define(e[6],t([0,1,3]),function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var r,i=Object.freeze(function(e,t){var n=setTimeout(e.bind(t),0);return{dispose:function(){clearTimeout(n)
}}});!function(e){e.isCancellationToken=function(t){return t===e.None||t===e.Cancelled||t instanceof o||!(!t||"object"!=typeof t)&&"boolean"==typeof t.isCancellationRequested&&"function"==typeof t.onCancellationRequested},e.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:n.Event.None}),e.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:i})}(r=t.CancellationToken||(t.CancellationToken={}));var o=function(){function e(){this._isCancelled=!1,this._emitter=null}return e.prototype.cancel=function(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))},Object.defineProperty(e.prototype,"isCancellationRequested",{get:function(){return this._isCancelled},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"onCancellationRequested",{get:function(){return this._isCancelled?i:(this._emitter||(this._emitter=new n.Emitter),this._emitter.event)},enumerable:!0,configurable:!0}),e.prototype.dispose=function(){
this._emitter&&(this._emitter.dispose(),this._emitter=null)},e}(),s=function(){function e(){}return Object.defineProperty(e.prototype,"token",{get:function(){return this._token||(this._token=new o),this._token},enumerable:!0,configurable:!0}),e.prototype.cancel=function(){this._token?this._token instanceof o&&this._token.cancel():this._token=r.Cancelled},e.prototype.dispose=function(){this._token?this._token instanceof o&&this._token.dispose():this._token=r.None},e}();t.CancellationTokenSource=s}),define(e[11],t([0,1,6,5,3,2]),function(e,t,r,i,o,s){"use strict";function u(e){return e&&"function"==typeof e.then}function c(e){var t=new r.CancellationTokenSource,n=e(t.token),o=new Promise(function(e,r){t.token.onCancellationRequested(function(){r(i.canceled())}),Promise.resolve(n).then(function(n){t.dispose(),e(n)},function(e){t.dispose(),r(e)})});return new(function(){function e(){}return e.prototype.cancel=function(){t.cancel()},e.prototype.then=function(e,t){return o.then(e,t)},e.prototype.catch=function(e){
return this.then(void 0,e)},e.prototype.finally=function(e){return l(o,e||function(){})},e}())}function a(e,t){return t?new Promise(function(n,r){var o=setTimeout(n,e);t.onCancellationRequested(function(){clearTimeout(o),r(i.canceled())})}):c(function(t){return a(e,t)})}function l(e,t){function n(){try{t()}catch(e){i.onUnexpectedError(e)}}return e.then(function(e){return n()},function(e){return n()}),Promise.resolve(e)}function f(e){function t(o){void 0!==o&&null!==o&&n.push(o);var s=r<i?e[r++]():null;return s?s.then(t):Promise.resolve(n)}var n=[],r=0,i=e.length;return Promise.resolve(null).then(t)}Object.defineProperty(t,"__esModule",{value:!0}),t.isThenable=u,t.createCancelablePromise=c,t.asPromise=function(e){return new Promise(function(t,n){var r=e();u(r)?r.then(t,n):t(r)})};var h=function(){function e(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}return e.prototype.queue=function(e){var t=this;if(this.activePromise){if(this.queuedPromiseFactory=e,!this.queuedPromise){
var n=function(){t.queuedPromise=null;var e=t.queue(t.queuedPromiseFactory);return t.queuedPromiseFactory=null,e};this.queuedPromise=new Promise(function(e){t.activePromise.then(n,n).then(e)})}return new Promise(function(e,n){t.queuedPromise.then(e,n)})}return this.activePromise=e(),new Promise(function(e,n){t.activePromise.then(function(n){t.activePromise=null,e(n)},function(e){t.activePromise=null,n(e)})})},e}();t.Throttler=h;var p=function(){function e(){this.current=Promise.resolve(null)}return e.prototype.queue=function(e){return this.current=this.current.then(function(){return e()})},e}();t.Sequencer=p;var d=function(){function e(e){this.defaultDelay=e,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.task=null}return e.prototype.trigger=function(e,t){var n=this;return void 0===t&&(t=this.defaultDelay),this.task=e,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise(function(e,t){n.doResolve=e,n.doReject=t}).then(function(){n.completionPromise=null,
n.doResolve=null;var e=n.task;return n.task=null,e()})),this.timeout=setTimeout(function(){n.timeout=null,n.doResolve(null)},t),this.completionPromise},e.prototype.isTriggered=function(){return null!==this.timeout},e.prototype.cancel=function(){this.cancelTimeout(),this.completionPromise&&(this.doReject(i.canceled()),this.completionPromise=null)},e.prototype.cancelTimeout=function(){null!==this.timeout&&(clearTimeout(this.timeout),this.timeout=null)},e.prototype.dispose=function(){this.cancelTimeout()},e}();t.Delayer=d;var v=function(){function e(e){this.delayer=new d(e),this.throttler=new h}return e.prototype.trigger=function(e,t){var n=this;return this.delayer.trigger(function(){return n.throttler.queue(e)},t)},e.prototype.isTriggered=function(){return this.delayer.isTriggered()},e.prototype.cancel=function(){this.delayer.cancel()},e.prototype.dispose=function(){this.delayer.dispose()},e}();t.ThrottledDelayer=v;var g=function(){function e(){var e=this;this._isOpen=!1,this._promise=new Promise(function(t,n){
e._completePromise=t})}return e.prototype.isOpen=function(){return this._isOpen},e.prototype.open=function(){this._isOpen=!0,this._completePromise(!0)},e.prototype.wait=function(){return this._promise},e}();t.Barrier=g,t.timeout=a,t.disposableTimeout=function(e,t){void 0===t&&(t=0);var n=setTimeout(e,t);return s.toDisposable(function(){return clearTimeout(n)})},t.always=l,t.ignoreErrors=function(e){return e.then(void 0,function(e){})},t.sequence=f,t.first=function(e,t,n){void 0===t&&(t=function(e){return!!e}),void 0===n&&(n=null);var r=0,i=e.length,o=function(){if(r>=i)return Promise.resolve(n);var s=e[r++];return Promise.resolve(s()).then(function(e){return t(e)?Promise.resolve(e):o()})};return o()};var y=function(){function e(e){this._size=0,this.maxDegreeOfParalellism=e,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new o.Emitter}return Object.defineProperty(e.prototype,"onFinished",{get:function(){return this._onFinished.event},enumerable:!0,configurable:!0}),
Object.defineProperty(e.prototype,"size",{get:function(){return this._size},enumerable:!0,configurable:!0}),e.prototype.queue=function(e){var t=this;return this._size++,new Promise(function(n,r){t.outstandingPromises.push({factory:e,c:n,e:r}),t.consume()})},e.prototype.consume=function(){for(var e=this;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){var t=this.outstandingPromises.shift();this.runningPromises++;var n=t.factory();n.then(t.c,t.e),n.then(function(){return e.consumed()},function(){return e.consumed()})}},e.prototype.consumed=function(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()},e.prototype.dispose=function(){this._onFinished.dispose()},e}();t.Limiter=y;var m=function(e){function t(){return e.call(this,1)||this}return n(t,e),t}(y);t.Queue=m;var b=function(){function e(){this.queues=Object.create(null)}return e.prototype.queueFor=function(e){var t=this,n=e.toString();if(!this.queues[n]){var r=new m
;r.onFinished(function(){r.dispose(),delete t.queues[n]}),this.queues[n]=r}return this.queues[n]},e}();t.ResourceQueue=b;var _=function(e){function t(t,n){var r=e.call(this)||this;return r._token=-1,"function"==typeof t&&"number"==typeof n&&r.setIfNotSet(t,n),r}return n(t,e),t.prototype.dispose=function(){this.cancel(),e.prototype.dispose.call(this)},t.prototype.cancel=function(){-1!==this._token&&(clearTimeout(this._token),this._token=-1)},t.prototype.cancelAndSet=function(e,t){var n=this;this.cancel(),this._token=setTimeout(function(){n._token=-1,e()},t)},t.prototype.setIfNotSet=function(e,t){var n=this;-1===this._token&&(this._token=setTimeout(function(){n._token=-1,e()},t))},t}(s.Disposable);t.TimeoutTimer=_;var w=function(e){function t(){var t=e.call(this)||this;return t._token=-1,t}return n(t,e),t.prototype.dispose=function(){this.cancel(),e.prototype.dispose.call(this)},t.prototype.cancel=function(){-1!==this._token&&(clearInterval(this._token),this._token=-1)},t.prototype.cancelAndSet=function(e,t){
this.cancel(),this._token=setInterval(function(){e()},t)},t}(s.Disposable);t.IntervalTimer=w;var C=function(){function e(e,t){this.timeoutToken=-1,this.runner=e,this.timeout=t,this.timeoutHandler=this.onTimeout.bind(this)}return e.prototype.dispose=function(){this.cancel(),this.runner=null},e.prototype.cancel=function(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)},e.prototype.schedule=function(e){void 0===e&&(e=this.timeout),this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,e)},e.prototype.isScheduled=function(){return-1!==this.timeoutToken},e.prototype.onTimeout=function(){this.timeoutToken=-1,this.runner&&this.doRun()},e.prototype.doRun=function(){this.runner&&this.runner()},e}();t.RunOnceScheduler=C;var E=function(e){function t(t,n){var r=e.call(this,t,n)||this;return r.units=[],r}return n(t,e),t.prototype.work=function(e){this.units.push(e),this.isScheduled()||this.schedule()},t.prototype.doRun=function(){var e=this.units;this.units=[],
this.runner&&this.runner(e)},t.prototype.dispose=function(){this.units=[],e.prototype.dispose.call(this)},t}(C);t.RunOnceWorker=E,t.nfcall=function(e){for(var t=[],n=1;n<arguments.length;n++)t[n-1]=arguments[n];return new Promise(function(n,r){return e.apply(void 0,t.concat([function(e,t){return e?r(e):n(t)}]))})},t.ninvoke=function(e,t){for(var n=[],r=2;r<arguments.length;r++)n[r-2]=arguments[r];return new Promise(function(r,i){return t.call.apply(t,[e].concat(n,[function(e,t){return e?i(e):r(t)}]))})},function(){if("function"!=typeof requestIdleCallback||"function"!=typeof cancelIdleCallback){var e=Object.freeze({didTimeout:!0,timeRemaining:function(){return 15}});t.runWhenIdle=function(t){var n=setTimeout(function(){return t(e)}),r=!1;return{dispose:function(){r||(r=!0,clearTimeout(n))}}}}else t.runWhenIdle=function(e,t){var n=requestIdleCallback(e,"number"==typeof t?{timeout:t}:void 0),r=!1;return{dispose:function(){r||(r=!0,cancelIdleCallback(n))}}}}();var P=function(){function e(e){var n=this
;this._executor=function(){try{n._value=e()}catch(e){n._error=e}finally{n._didRun=!0}},this._handle=t.runWhenIdle(function(){return n._executor()})}return e.prototype.dispose=function(){this._handle.dispose()},e.prototype.getValue=function(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value},e}();t.IdleValue=P}),define(e[4],t([0,1]),function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var n=!1,r=!1,i=!1,o=!1,s=!1,u=void 0,c=void 0,a=void 0;t.LANGUAGE_DEFAULT="en";var l="undefined"!=typeof process&&void 0!==process.versions&&void 0!==process.versions.electron&&"renderer"===process.type;if("object"!=typeof navigator||l){if("object"==typeof process){n="win32"===process.platform,r="darwin"===process.platform,i="linux"===process.platform,u=t.LANGUAGE_DEFAULT,c=t.LANGUAGE_DEFAULT;var f=process.env.VSCODE_NLS_CONFIG;if(f)try{var h=JSON.parse(f),p=h.availableLanguages["*"];u=h.locale,c=p||t.LANGUAGE_DEFAULT,a=h._translationsConfigFile
}catch(e){}o=!0}}else{var d=navigator.userAgent;n=d.indexOf("Windows")>=0,r=d.indexOf("Macintosh")>=0,i=d.indexOf("Linux")>=0,s=!0,c=u=navigator.language}!function(e){e[e.Web=0]="Web",e[e.Mac=1]="Mac",e[e.Linux=2]="Linux",e[e.Windows=3]="Windows"}(t.Platform||(t.Platform={})),t.PlatformToString=function(e){switch(e){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}};var v=0;o&&(r?v=1:n?v=3:i&&(v=2)),t.isWindows=n,t.isMacintosh=r,t.isLinux=i,t.isNative=o,t.isWeb=s,t.platform=v,t.isRootUser=function(){return o&&!n&&0===process.getuid()},t.language=c,t.locale=u,t.translationsConfigFile=a;var g="object"==typeof self?self:"object"==typeof global?global:{};t.globals=g;var y=null;t.setImmediate=function(e){return null===y&&(y=t.globals.setImmediate?t.globals.setImmediate.bind(t.globals):"undefined"!=typeof process&&"function"==typeof process.nextTick?process.nextTick.bind(process):t.globals.setTimeout.bind(t.globals)),y(e)};!function(e){e[e.Windows=1]="Windows",
e[e.Macintosh=2]="Macintosh",e[e.Linux=3]="Linux"}(t.OperatingSystem||(t.OperatingSystem={})),t.OS=r?2:n?1:3;!function(e){e[e.Unknown=0]="Unknown",e[e.Disabled=1]="Disabled",e[e.Enabled=2]="Enabled"}(t.AccessibilitySupport||(t.AccessibilitySupport={}))}),define(e[17],t([0,1]),function(e,t){"use strict";function n(e){return e.replace(/[\-\\\{\}\*\+\?\|\^\$\.\[\]\(\)\#]/g,"\\$&")}function r(e,t){if(!e||!t)return e;var n=t.length;if(0===n||0===e.length)return e;for(var r=0;e.indexOf(t,r)===r;)r+=n;return e.substring(r)}function i(e,t){if(!e||!t)return e;var n=t.length,r=e.length;if(0===n||0===r)return e;for(var i=r,o=-1;;){if(-1===(o=e.lastIndexOf(t,i-1))||o+n!==i)break;if(0===o)return"";i=o}return e.substring(0,i)}function o(e,t){return e<t?-1:e>t?1:0}function s(e){return e>=97&&e<=122}function u(e){return e>=65&&e<=90}function c(e){return s(e)||u(e)}function a(e,t,n){if(void 0===n&&(n=e.length),"string"!=typeof e||"string"!=typeof t)return!1;for(var r=0;r<n;r++){var i=e.charCodeAt(r),o=t.charCodeAt(r)
;if(i!==o)if(c(i)&&c(o)){var s=Math.abs(i-o);if(0!==s&&32!==s)return!1}else if(String.fromCharCode(i).toLowerCase()!==String.fromCharCode(o).toLowerCase())return!1}return!0}function l(e,t,n,r,i,o){for(;t<n&&i<o;){if(e[t]!==r[i])return!1;t+=1,i+=1}return!0}function f(e){return(e=+e)>=11904&&e<=55215||e>=63744&&e<=64255||e>=65281&&e<=65374}function h(e){return!!(e&&e.length>0&&65279===e.charCodeAt(0))}Object.defineProperty(t,"__esModule",{value:!0}),t.empty="",t.isFalsyOrWhitespace=function(e){return!e||"string"!=typeof e||0===e.trim().length},t.pad=function(e,t,n){void 0===n&&(n="0");for(var r=""+e,i=[r],o=r.length;o<t;o++)i.push(n);return i.reverse().join("")};var p=/{(\d+)}/g;t.format=function(e){for(var t=[],n=1;n<arguments.length;n++)t[n-1]=arguments[n];return 0===t.length?e:e.replace(p,function(e,n){var r=parseInt(n,10);return isNaN(r)||r<0||r>=t.length?e:t[r]})},t.escape=function(e){return e.replace(/[<>&]/g,function(e){switch(e){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:
return e}})},t.escapeRegExpCharacters=n,t.trim=function(e,t){return void 0===t&&(t=" "),i(r(e,t),t)},t.ltrim=r,t.rtrim=i,t.convertSimple2RegExpPattern=function(e){return e.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")},t.stripWildcards=function(e){return e.replace(/\*/g,"")},t.startsWith=function(e,t){if(e.length<t.length)return!1;if(e===t)return!0;for(var n=0;n<t.length;n++)if(e[n]!==t[n])return!1;return!0},t.endsWith=function(e,t){var n=e.length-t.length;return n>0?e.indexOf(t,n)===n:0===n&&e===t},t.createRegExp=function(e,t,r){if(void 0===r&&(r={}),!e)throw new Error("Cannot create regex from empty string");t||(e=n(e)),r.wholeWord&&(/\B/.test(e.charAt(0))||(e="\\b"+e),/\B/.test(e.charAt(e.length-1))||(e+="\\b"));var i="";return r.global&&(i+="g"),r.matchCase||(i+="i"),r.multiline&&(i+="m"),r.unicode&&(i+="u"),new RegExp(e,i)},t.regExpLeadsToEndlessLoop=function(e){return"^"!==e.source&&"^$"!==e.source&&"$"!==e.source&&"^\\s*$"!==e.source&&!(!e.exec("")||0!==e.lastIndex)},
t.regExpContainsBackreference=function(e){return!!e.match(/([^\\]|^)(\\\\)*\\\d+/)},t.regExpFlags=function(e){return(e.global?"g":"")+(e.ignoreCase?"i":"")+(e.multiline?"m":"")+(e.unicode?"u":"")},t.firstNonWhitespaceIndex=function(e){for(var t=0,n=e.length;t<n;t++){var r=e.charCodeAt(t);if(32!==r&&9!==r)return t}return-1},t.getLeadingWhitespace=function(e,t,n){void 0===t&&(t=0),void 0===n&&(n=e.length);for(var r=t;r<n;r++){var i=e.charCodeAt(r);if(32!==i&&9!==i)return e.substring(t,r)}return e.substring(t,n)},t.lastNonWhitespaceIndex=function(e,t){void 0===t&&(t=e.length-1);for(var n=t;n>=0;n--){var r=e.charCodeAt(n);if(32!==r&&9!==r)return n}return-1},t.compare=o,t.compareIgnoreCase=function(e,t){for(var n=Math.min(e.length,t.length),r=0;r<n;r++){var i=e.charCodeAt(r),c=t.charCodeAt(r);if(i!==c){u(i)&&(i+=32),u(c)&&(c+=32);var a=i-c;if(0!==a)return s(i)&&s(c)?a:o(e.toLowerCase(),t.toLowerCase())}}return e.length<t.length?-1:e.length>t.length?1:0},t.isLowerAsciiLetter=s,t.isUpperAsciiLetter=u,
t.equalsIgnoreCase=function(e,t){return(e?e.length:0)===(t?t.length:0)&&a(e,t)},t.startsWithIgnoreCase=function(e,t){var n=t.length;return!(t.length>e.length)&&a(e,t,n)},t.commonPrefixLength=function(e,t){var n,r=Math.min(e.length,t.length);for(n=0;n<r;n++)if(e.charCodeAt(n)!==t.charCodeAt(n))return n;return r},t.commonSuffixLength=function(e,t){var n,r=Math.min(e.length,t.length),i=e.length-1,o=t.length-1;for(n=0;n<r;n++)if(e.charCodeAt(i-n)!==t.charCodeAt(o-n))return n;return r},t.overlap=function(e,t){var n=e.length,r=t.length,i=n-r;if(0===i)return e===t?n:0;for(i<0&&(r+=i,i=0);i<n&&r>0;){if(l(e,i,n,t,0,r))return r;r-=1,i+=1}return 0},t.isHighSurrogate=function(e){return 55296<=e&&e<=56319},t.isLowSurrogate=function(e){return 56320<=e&&e<=57343}
;var d=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;t.containsRTL=function(e){return d.test(e)};var v=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEF8]|\uD83E[\uDD00-\uDDE6])/;t.containsEmoji=function(e){return v.test(e)};var g=/^[\t\n\r\x20-\x7E]*$/;t.isBasicASCII=function(e){return g.test(e)},t.containsFullWidthCharacter=function(e){for(var t=0,n=e.length;t<n;t++)if(f(e.charCodeAt(t)))return!0;return!1},t.isFullWidthCharacter=f,t.lcut=function(e,n){if(e.length<n)return e
;for(var r=/\b/g,i=0;r.test(e)&&!(e.length-r.lastIndex<n);)i=r.lastIndex,r.lastIndex+=1;return e.substring(i).replace(/^\s/,t.empty)};var y=/\x1B\x5B[12]?K/g,m=/\x1b\[\d+m/g,b=/\x1b\[0?m/g;t.removeAnsiEscapeCodes=function(e){return e&&(e=(e=(e=e.replace(y,"")).replace(m,"")).replace(b,"")),e},t.UTF8_BOM_CHARACTER=String.fromCharCode(65279),t.startsWithUTF8BOM=h,t.stripUTF8BOM=function(e){return h(e)?e.substr(1):e},t.safeBtoa=function(e){return btoa(encodeURIComponent(e))},t.repeat=function(e,t){for(var n="",r=0;r<t;r++)n+=e;return n},t.fuzzyContains=function(e,t){if(!e||!t)return!1;if(e.length<t.length)return!1;for(var n=t.length,r=e.toLowerCase(),i=0,o=-1;i<n;){var s=r.indexOf(t[i],o+1);if(s<0)return!1;o=s,i++}return!0},t.containsUppercaseCharacter=function(e,t){return void 0===t&&(t=!1),!!e&&(t&&(e=e.replace(/\\./g,"")),e.toLowerCase()!==e)},t.uppercaseFirstLetter=function(e){return e.charAt(0).toUpperCase()+e.slice(1)},t.getNLines=function(e,t){if(void 0===t&&(t=1),0===t)return"";var n=-1;do{
n=e.indexOf("\n",n+1),t--}while(t>0&&n>=0);return n>=0?e.substr(0,n):e}}),define(e[12],t([0,1,4,17]),function(e,t,n,r){"use strict";function i(e){return 47===e||92===e}function o(e){var t=~e.lastIndexOf("/")||~e.lastIndexOf("\\");return 0===t?e:~t==e.length-1?o(e.substring(0,e.length-1)):e.substr(1+~t)}function s(e,t){if(null===e||void 0===e)return e;var r=e.length;if(0===r)return".";var o=!(!n.isWindows||!t);if(function(e,t){return t?!p.test(e):!h.test(e)}(e,o))return e;for(var s=o?"\\":"/",a=c(e,s),l=a.length,f=!1,d="",v=a.length;v<=r;v++)if(v===r||i(e.charCodeAt(v))){if(u(e,l,v,"..")){var g=d.lastIndexOf(s),y=d.slice(g+1);(a||y.length>0)&&".."!==y&&(d=-1===g?"":d.slice(0,g),f=!0)}else u(e,l,v,".")&&(a||d||v<r-1)&&(f=!0);if(!f){var m=e.slice(l,v);""!==d&&d[d.length-1]!==s&&(d+=s),d+=m}l=v+1,f=!1}return a+d}function u(e,t,n,r){return t+r.length===n&&e.indexOf(r,t)===t}function c(e,t){if(void 0===t&&(t="/"),!e)return"";var n=e.length,r=e.charCodeAt(0);if(i(r)){if(i(e.charCodeAt(1))&&!i(e.charCodeAt(2))){
for(var o=3,s=o;o<n&&!i(e.charCodeAt(o));o++);if(s!==o&&!i(e.charCodeAt(o+1)))for(o+=1;o<n;o++)if(i(e.charCodeAt(o)))return e.slice(0,o+1).replace(/[\\/]/g,t)}return t}if(f(r)&&58===e.charCodeAt(1))return i(e.charCodeAt(2))?e.slice(0,2)+t:e.slice(0,2);var u=e.indexOf("://");if(-1!==u)for(u+=3;u<n;u++)if(i(e.charCodeAt(u)))return e.slice(0,u+1);return""}function a(e){if(!e)return!1;var t=e.charCodeAt(0);if(i(t))return!0;if(f(t)&&e.length>2&&58===e.charCodeAt(1)){if(i(e.charCodeAt(2)))return!0}return!1}function l(e){return!(!e||47!==e.charCodeAt(0))}function f(e){return e>=65&&e<=90||e>=97&&e<=122}Object.defineProperty(t,"__esModule",{value:!0}),t.sep="/",t.nativeSep=n.isWindows?"\\":"/",t.dirname=function(e,n){void 0===n&&(n=t.nativeSep);var r=e.length;if(0===r)return".";if(1===r)return i(e.charCodeAt(0))?e:".";var o=c(e,n).length;if(o>=r)return e;0===o&&i(e.charCodeAt(0))&&(o=1);var s=r-1;if(s>o)for(s--;s>o&&!i(e.charCodeAt(s));)s--;return 0===s?".":e.substr(0,s)},t.basename=o,t.extname=function(e){
var t=~(e=o(e)).lastIndexOf(".");return t?e.substring(~t):""};var h=/(\/\.\.?\/)|(\/\.\.?)$|^(\.\.?\/)|(\/\/+)|(\\)/,p=/(\\\.\.?\\)|(\\\.\.?)$|^(\.\.?\\)|(\\\\+)|(\/)/;t.normalize=s,t.getRoot=c,t.join=function(){for(var e="",n=0;n<arguments.length;n++){var r=arguments[n];if(n>0){if(!i(e.charCodeAt(e.length-1))){i(r.charCodeAt(0))||(e+=t.sep)}}e+=r}return s(e)},t.isUNC=function(e){if(!n.isWindows)return!1;if(!e||e.length<5)return!1;var t=e.charCodeAt(0);if(92!==t)return!1;if(92!==(t=e.charCodeAt(1)))return!1;for(var r=2,i=r;r<e.length&&92!==(t=e.charCodeAt(r));r++);return i!==r&&(t=e.charCodeAt(r+1),!isNaN(t)&&92!==t)};var d=n.isWindows?/[\\/:\*\?"<>\|]/g:/[\\/]/g,v=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])$/i;t.isValidBasename=function(e){return!(!e||0===e.length||/^\s+$/.test(e)||(d.lastIndex=0,d.test(e)||n.isWindows&&v.test(e)||"."===e||".."===e||n.isWindows&&"."===e[e.length-1]||n.isWindows&&e.length!==e.trim().length))},t.isEqual=function(e,t,n){var i=e===t
;return!n||i?i:!(!e||!t)&&r.equalsIgnoreCase(e,t)},t.isEqualOrParent=function(e,n,i,o){if(void 0===o&&(o=t.nativeSep),e===n)return!0;if(!e||!n)return!1;if(n.length>e.length)return!1;if(i){if(!r.startsWithIgnoreCase(e,n))return!1;if(n.length===e.length)return!0;var s=n.length;return n.charAt(n.length-1)===o&&s--,e.charAt(s)===o}return n.charAt(n.length-1)!==o&&(n+=o),0===e.indexOf(n)},t.isAbsolute=function(e){return n.isWindows?a(e):l(e)},t.isAbsolute_win32=a,t.isAbsolute_posix=l,t.isWindowsDriveLetter=f}),define(e[7],t([0,1]),function(e,t){"use strict";function n(e){return Array.isArray?Array.isArray(e):!(!e||typeof e.length!==a.number||e.constructor!==Array)}function r(e){return typeof e===a.string||e instanceof String}function i(e){return!(typeof e!==a.object||null===e||Array.isArray(e)||e instanceof RegExp||e instanceof Date)}function o(e){return typeof e===a.undefined}function s(e){return o(e)||null===e}function u(e){return typeof e===a.function}function c(e,t){if(r(t)){
if(typeof e!==t)throw new Error("argument does not match constraint: typeof "+t)}else if(u(t)){if(e instanceof t)return;if(!s(e)&&e.constructor===t)return;if(1===t.length&&!0===t.call(void 0,e))return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}Object.defineProperty(t,"__esModule",{value:!0});var a={number:"number",string:"string",undefined:"undefined",object:"object",function:"function"};t.isArray=n,t.isString=r,t.isStringArray=function(e){return n(e)&&e.every(function(e){return r(e)})},t.isObject=i,t.isNumber=function(e){return(typeof e===a.number||e instanceof Number)&&!isNaN(e)},t.isBoolean=function(e){return!0===e||!1===e},t.isUndefined=o,t.isUndefinedOrNull=s;var l=Object.prototype.hasOwnProperty;t.isEmptyObject=function(e){if(!i(e))return!1;for(var t in e)if(l.call(e,t))return!1;return!0},t.isFunction=u,t.areFunctions=function(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t]
;return e.length>0&&e.every(u)},t.validateConstraints=function(e,t){for(var n=Math.min(e.length,t.length),r=0;r<n;r++)c(e[r],t[r])},t.validateConstraint=c,t.create=function(e){for(var t=[],n=1;n<arguments.length;n++)t[n-1]=arguments[n];var r=Object.create(e.prototype);return e.apply(r,t),r}}),define(e[8],t([0,1,7]),function(e,t,n){"use strict";function r(e){if(!e||"object"!=typeof e)return e;if(e instanceof RegExp)return e;var t=Array.isArray(e)?[]:{};return Object.keys(e).forEach(function(n){e[n]&&"object"==typeof e[n]?t[n]=r(e[n]):t[n]=e[n]}),t}function i(e,t,r){if(n.isUndefinedOrNull(e))return e;var o=t(e);if(void 0!==o)return o;if(n.isArray(e)){for(var s=[],c=0,a=e;c<a.length;c++){var l=a[c];s.push(i(l,t,r))}return s}if(n.isObject(e)){if(r.has(e))throw new Error("Cannot clone recursive data-structure");r.add(e);var f={};for(var h in e)u.call(e,h)&&(f[h]=i(e[h],t,r));return r.delete(e),f}return e}function o(e,t,r){return void 0===r&&(r=!0),n.isObject(e)?(n.isObject(t)&&Object.keys(t).forEach(function(i){
i in e?r&&(n.isObject(e[i])&&n.isObject(t[i])?o(e[i],t[i],r):e[i]=t[i]):e[i]=t[i]}),e):t}function s(e,t){if(e===t)return!0;if(null===e||void 0===e||null===t||void 0===t)return!1;if(typeof e!=typeof t)return!1;if("object"!=typeof e)return!1;if(Array.isArray(e)!==Array.isArray(t))return!1;var n,r;if(Array.isArray(e)){if(e.length!==t.length)return!1;for(n=0;n<e.length;n++)if(!s(e[n],t[n]))return!1}else{var i=[];for(r in e)i.push(r);i.sort();var o=[];for(r in t)o.push(r);if(o.sort(),!s(i,o))return!1;for(n=0;n<i.length;n++)if(!s(e[i[n]],t[i[n]]))return!1}return!0}Object.defineProperty(t,"__esModule",{value:!0}),t.deepClone=r,t.deepFreeze=function(e){if(!e||"object"!=typeof e)return e;for(var t=[e];t.length>0;){var n=t.shift();Object.freeze(n);for(var r in n)if(u.call(n,r)){var i=n[r];"object"!=typeof i||Object.isFrozen(i)||t.push(i)}}return e};var u=Object.prototype.hasOwnProperty;t.cloneAndChange=function(e,t){return i(e,t,new Set)},t.mixin=o,t.assign=function(e){
for(var t=[],n=1;n<arguments.length;n++)t[n-1]=arguments[n];return t.forEach(function(t){return Object.keys(t).forEach(function(n){return e[n]=t[n]})}),e},t.equals=s,t.createKeywordMatcher=function(e,t){void 0===t&&(t=!1),t&&(e=e.map(function(e){return e.toLowerCase()}));var n=function(t){for(var n={},r=0,i=e;r<i.length;r++)n[i[r]]=!0;return n}();return t?function(e){return void 0!==n[e.toLowerCase()]&&n.hasOwnProperty(e.toLowerCase())}:function(e){return void 0!==n[e]&&n.hasOwnProperty(e)}},t.safeStringify=function(e){var t=[];return JSON.stringify(e,function(e,r){if(n.isObject(r)||Array.isArray(r)){if(-1!==t.indexOf(r))return"[Circular]";t.push(r)}return r})},t.getOrDefault=function(e,t,n){var r=t(e);return void 0===r?n:r},t.distinct=function(e,t){var n=Object.create(null);return e&&t?(Object.keys(t).forEach(function(r){var i=e[r],o=t[r];s(i,o)||(n[r]=o)}),n):n}}),define(e[10],t([0,1,4]),function(e,t,r){"use strict";function i(e,t){for(var n=void 0,r=-1,i=0;i<e.length;i++){var o=e.charCodeAt(i)
;if(o>=97&&o<=122||o>=65&&o<=90||o>=48&&o<=57||45===o||46===o||95===o||126===o||t&&47===o)-1!==r&&(n+=encodeURIComponent(e.substring(r,i)),r=-1),void 0!==n&&(n+=e.charAt(i));else{void 0===n&&(n=e.substr(0,i));var s=y[o];void 0!==s?(-1!==r&&(n+=encodeURIComponent(e.substring(r,i)),r=-1),n+=s):-1===r&&(r=i)}}return-1!==r&&(n+=encodeURIComponent(e.substring(r))),void 0!==n?n:e}function o(e){var t;return t=e.authority&&e.path.length>1&&"file"===e.scheme?"//"+e.authority+e.path:47===e.path.charCodeAt(0)&&(e.path.charCodeAt(1)>=65&&e.path.charCodeAt(1)<=90||e.path.charCodeAt(1)>=97&&e.path.charCodeAt(1)<=122)&&58===e.path.charCodeAt(2)?e.path[1].toLowerCase()+e.path.substr(2):e.path,r.isWindows&&(t=t.replace(/\//g,"\\")),t}function s(e,t){var n=t?function(e){for(var t=void 0,n=0;n<e.length;n++){var r=e.charCodeAt(n);35===r||63===r?(void 0===t&&(t=e.substr(0,n)),t+=y[r]):void 0!==t&&(t+=e[n])}return void 0!==t?t:e}:i,r="",o=e.scheme,s=e.authority,u=e.path,c=e.query,a=e.fragment;if(o&&(r+=o,r+=":"),
(s||"file"===o)&&(r+=p,r+=p),s){var l=s.indexOf("@");if(-1!==l){var f=s.substr(0,l);s=s.substr(l+1),-1===(l=f.indexOf(":"))?r+=n(f,!1):(r+=n(f.substr(0,l),!1),r+=":",r+=n(f.substr(l+1),!1)),r+="@"}-1===(l=(s=s.toLowerCase()).indexOf(":"))?r+=n(s,!1):(r+=n(s.substr(0,l),!1),r+=s.substr(l))}if(u){if(u.length>=3&&47===u.charCodeAt(0)&&58===u.charCodeAt(2)){(h=u.charCodeAt(1))>=65&&h<=90&&(u="/"+String.fromCharCode(h+32)+":"+u.substr(3))}else if(u.length>=2&&58===u.charCodeAt(1)){var h=u.charCodeAt(0);h>=65&&h<=90&&(u=String.fromCharCode(h+32)+":"+u.substr(2))}r+=n(u,!0)}return c&&(r+="?",r+=n(c,!1)),a&&(r+="#",r+=t?a:i(a,!1)),r}Object.defineProperty(t,"__esModule",{value:!0});var u,c=/^\w[\w\d+.-]*$/,a=/^\//,l=/^\/\//,f=!0;t.setUriThrowOnMissingScheme=function(e){var t=f;return f=e,t};var h="",p="/",d=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/,v=function(){function e(e,t,n,r,i,o){"object"==typeof e?(this.scheme=e.scheme||h,this.authority=e.authority||h,this.path=e.path||h,
this.query=e.query||h,this.fragment=e.fragment||h):(this.scheme=e||h,this.authority=t||h,this.path=function(e,t){switch(e){case"https":case"http":case"file":t?t[0]!==p&&(t=p+t):t=p}return t}(this.scheme,n||h),this.query=r||h,this.fragment=i||h,function(e,t){if(!e.scheme){if(t||f)throw new Error('[UriError]: Scheme is missing: {scheme: "", authority: "'+e.authority+'", path: "'+e.path+'", query: "'+e.query+'", fragment: "'+e.fragment+'"}');console.warn('[UriError]: Scheme is missing: {scheme: "", authority: "'+e.authority+'", path: "'+e.path+'", query: "'+e.query+'", fragment: "'+e.fragment+'"}')}if(e.scheme&&!c.test(e.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(e.path)if(e.authority){if(!a.test(e.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')
}else if(l.test(e.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}(this,o))}return e.isUri=function(t){return t instanceof e||!!t&&("string"==typeof t.authority&&"string"==typeof t.fragment&&"string"==typeof t.path&&"string"==typeof t.query&&"string"==typeof t.scheme&&"function"==typeof t.fsPath&&"function"==typeof t.with&&"function"==typeof t.toString)},Object.defineProperty(e.prototype,"fsPath",{get:function(){return o(this)},enumerable:!0,configurable:!0}),e.prototype.with=function(e){if(!e)return this;var t=e.scheme,n=e.authority,r=e.path,i=e.query,o=e.fragment;return void 0===t?t=this.scheme:null===t&&(t=h),void 0===n?n=this.authority:null===n&&(n=h),void 0===r?r=this.path:null===r&&(r=h),void 0===i?i=this.query:null===i&&(i=h),void 0===o?o=this.fragment:null===o&&(o=h),t===this.scheme&&n===this.authority&&r===this.path&&i===this.query&&o===this.fragment?this:new g(t,n,r,i,o)},e.parse=function(e,t){
void 0===t&&(t=!1);var n=d.exec(e);return n?new g(n[2]||h,decodeURIComponent(n[4]||h),decodeURIComponent(n[5]||h),decodeURIComponent(n[7]||h),decodeURIComponent(n[9]||h),t):new g(h,h,h,h,h)},e.file=function(e){var t=h;if(r.isWindows&&(e=e.replace(/\\/g,p)),e[0]===p&&e[1]===p){var n=e.indexOf(p,2);-1===n?(t=e.substring(2),e=p):(t=e.substring(2,n),e=e.substring(n)||p)}return new g("file",t,e,h,h)},e.from=function(e){return new g(e.scheme,e.authority,e.path,e.query,e.fragment)},e.prototype.toString=function(e){return void 0===e&&(e=!1),s(this,e)},e.prototype.toJSON=function(){return this},e.revive=function(t){if(t){if(t instanceof e)return t;var n=new g(t);return n._fsPath=t.fsPath,n._formatted=t.external,n}return t},e}();t.URI=v;var g=function(e){function t(){var t=null!==e&&e.apply(this,arguments)||this;return t._formatted=null,t._fsPath=null,t}return n(t,e),Object.defineProperty(t.prototype,"fsPath",{get:function(){return this._fsPath||(this._fsPath=o(this)),this._fsPath},enumerable:!0,configurable:!0}),
t.prototype.toString=function(e){return void 0===e&&(e=!1),e?s(this,!0):(this._formatted||(this._formatted=s(this,!1)),this._formatted)},t.prototype.toJSON=function(){var e={$mid:1};return this._fsPath&&(e.fsPath=this._fsPath),this._formatted&&(e.external=this._formatted),this.path&&(e.path=this.path),this.scheme&&(e.scheme=this.scheme),this.authority&&(e.authority=this.authority),this.query&&(e.query=this.query),this.fragment&&(e.fragment=this.fragment),e},t}(v),y=(u={},u[58]="%3A",u[47]="%2F",u[63]="%3F",u[35]="%23",u[91]="%5B",u[93]="%5D",u[64]="%40",u[33]="%21",u[36]="%24",u[38]="%26",u[39]="%27",u[40]="%28",u[41]="%29",u[42]="%2A",u[43]="%2B",u[44]="%2C",u[59]="%3B",u[61]="%3D",u[32]="%20",u)}),define(e[16],t([0,1,10]),function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getPathFromAmdModule=function(e,t){return n.URI.parse(e.toUrl(t)).fsPath}}),define(e[13],t([0,1,10]),function(e,t,n){"use strict";function r(e){var t,n=[];try{var r=JSON.parse(e.arguments),i=r[r.length-1]
;i&&i.__$stack&&(r.pop(),t=i.__$stack),n.push.apply(n,r)}catch(t){n.push("Unable to log remote console arguments",e.arguments)}return{args:n,stack:t}}function i(e){if("string"!=typeof e)return i(r(e).stack);var t=e;if(t){var s=o(t),u=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(s||"");if(u&&4===u.length)return{uri:n.URI.file(u[1]),line:Number(u[2]),column:Number(u[3])}}}function o(e){if(!e)return e;var t=e.indexOf("\n");return-1===t?e:e.substring(0,t)}function s(e){return"color: "+e}Object.defineProperty(t,"__esModule",{value:!0}),t.isRemoteConsoleLog=function(e){var t=e;return t&&"string"==typeof t.type&&"string"==typeof t.severity},t.parse=r,t.getFirstFrame=i,t.log=function(e,t){var n=r(e),i=n.args,u=n.stack,c="string"==typeof i[0]&&1===i.length,a=o(u);a&&(a="("+a.trim()+")");var l=[];l="string"==typeof i[0]?a&&c?["%c["+t+"] %c"+i[0]+" %c"+a,s("blue"),s("black"),s("grey")]:["%c["+t+"] %c"+i[0],s("blue"),s("black")].concat(i.slice(1)):["%c["+t+"]%",s("blue")].concat(i),
a&&!c&&l.push(a),console[e.severity].apply(console,l)}}),define(e[18],t([0,1,33]),function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var r=function(){function e(e){void 0===e&&(e="utf8"),this.stringDecoder=new n.StringDecoder(e),this.remaining=null}return e.prototype.write=function(e){var t=[],n=this.remaining?this.remaining+this.stringDecoder.write(e):this.stringDecoder.write(e);if(n.length<1)return t;for(var r,i=0,o=i;o<n.length;)if(13===(r=n.charCodeAt(o))||10===r){if(t.push(n.substring(i,o)),++o<n.length){var s=r;r=n.charCodeAt(o),(13===s&&10===r||10===s&&13===r)&&o++}i=o}else o++;return this.remaining=i<n.length?n.substr(i):null,t},e.prototype.end=function(){return this.remaining},e}();t.LineDecoder=r}),define(e[20],t([0,1,2,3,11,6,5]),function(e,t,n,o,s,u,c){"use strict";function a(e){var t=Buffer.allocUnsafe(4);return t.writeUInt32BE(e,0),t}function l(e){return e.read(4).readUInt32BE(0)}function f(e,t){if(void 0===t)e.write(m.Undefined);else if("string"==typeof t){
i=Buffer.from(t);e.write(m.String),e.write(a(i.length)),e.write(i)}else if(Buffer.isBuffer(t))e.write(m.Buffer),e.write(a(t.length)),e.write(t);else if(Array.isArray(t)){e.write(m.Array),e.write(a(t.length));for(var n=0,r=t;n<r.length;n++){f(e,r[n])}}else{var i=Buffer.from(JSON.stringify(t));e.write(m.Object),e.write(a(i.length)),e.write(i)}}function h(e){switch(e.read(1).readUInt8(0)){case v.Undefined:return;case v.String:return e.read(l(e)).toString();case v.Buffer:return e.read(l(e));case v.Array:for(var t=l(e),n=[],r=0;r<t;r++)n.push(h(e));return n;case v.Object:return JSON.parse(e.read(l(e)).toString())}}function p(e){return{call:function(t,n,r){return e.then(function(e){return e.call(t,n,r)})},listen:function(t,n){var r=new o.Relay;return e.then(function(e){return r.input=e.listen(t,n)}),r.event}}}Object.defineProperty(t,"__esModule",{value:!0});!function(e){e[e.Promise=100]="Promise",e[e.PromiseCancel=101]="PromiseCancel",e[e.EventListen=102]="EventListen",e[e.EventDispose=103]="EventDispose"
}(t.RequestType||(t.RequestType={}));!function(e){e[e.Initialize=200]="Initialize",e[e.PromiseSuccess=201]="PromiseSuccess",e[e.PromiseError=202]="PromiseError",e[e.PromiseErrorObj=203]="PromiseErrorObj",e[e.EventFire=204]="EventFire"}(t.ResponseType||(t.ResponseType={}));var d;!function(e){e[e.Uninitialized=0]="Uninitialized",e[e.Idle=1]="Idle"}(d||(d={}));var v,g=function(){function e(e){this.buffer=e,this.pos=0}return e.prototype.read=function(e){var t=this.buffer.slice(this.pos,this.pos+e);return this.pos+=t.length,t},e}(),y=function(){function e(){this.buffers=[]}return Object.defineProperty(e.prototype,"buffer",{get:function(){return Buffer.concat(this.buffers)},enumerable:!0,configurable:!0}),e.prototype.write=function(e){this.buffers.push(e)},e}();!function(e){e[e.Undefined=0]="Undefined",e[e.String=1]="String",e[e.Buffer=2]="Buffer",e[e.Array=3]="Array",e[e.Object=4]="Object"}(v||(v={}));var m={Undefined:Buffer.alloc(1,v.Undefined),String:Buffer.alloc(1,v.String),Buffer:Buffer.alloc(1,v.Buffer),
Array:Buffer.alloc(1,v.Array),Object:Buffer.alloc(1,v.Object)},b=function(){function e(e,t){var n=this;this.protocol=e,this.ctx=t,this.channels=new Map,this.activeRequests=new Map,this.protocolListener=this.protocol.onMessage(function(e){return n.onRawMessage(e)}),this.sendResponse({type:200})}return e.prototype.registerChannel=function(e,t){this.channels.set(e,t)},e.prototype.sendResponse=function(e){switch(e.type){case 200:return this.send([e.type]);case 201:case 202:case 204:case 203:return this.send([e.type,e.id],e.data)}},e.prototype.send=function(e,t){void 0===t&&(t=void 0);var n=new y;f(n,e),f(n,t),this.sendBuffer(n.buffer)},e.prototype.sendBuffer=function(e){try{this.protocol.send(e)}catch(e){}},e.prototype.onRawMessage=function(e){var t=new g(e),n=h(t),r=h(t),i=n[0];switch(i){case 100:return this.onPromise({type:i,id:n[1],channelName:n[2],name:n[3],arg:r});case 102:return this.onEventListen({type:i,id:n[1],channelName:n[2],name:n[3],arg:r});case 101:case 103:return this.disposeActiveRequest({type:i,
id:n[1]})}},e.prototype.onPromise=function(e){var t=this,r=this.channels.get(e.channelName);if(!r)throw new Error("Unknown channel");var i,o=new u.CancellationTokenSource;try{i=r.call(this.ctx,e.name,e.arg,o.token)}catch(e){i=Promise.reject(e)}var s=e.id;i.then(function(n){t.sendResponse({id:s,data:n,type:201}),t.activeRequests.delete(e.id)},function(n){n instanceof Error?t.sendResponse({id:s,data:{message:n.message,name:n.name,stack:n.stack?n.stack.split?n.stack.split("\n"):n.stack:void 0},type:202}):t.sendResponse({id:s,data:n,type:203}),t.activeRequests.delete(e.id)});var c=n.toDisposable(function(){return o.cancel()});this.activeRequests.set(e.id,c)},e.prototype.onEventListen=function(e){var t=this,n=this.channels.get(e.channelName);if(!n)throw new Error("Unknown channel");var r=e.id,i=n.listen(this.ctx,e.name,e.arg)(function(e){return t.sendResponse({id:r,data:e,type:204})});this.activeRequests.set(e.id,i)},e.prototype.disposeActiveRequest=function(e){var t=this.activeRequests.get(e.id);t&&(t.dispose(),
this.activeRequests.delete(e.id))},e.prototype.dispose=function(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(function(e){return e.dispose()}),this.activeRequests.clear()},e}();t.ChannelServer=b;var _=function(){function e(e){var t=this;this.protocol=e,this.state=d.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new o.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(function(e){return t.onBuffer(e)})}return e.prototype.getChannel=function(e){var t=this;return{call:function(n,r,i){return t.requestPromise(e,n,r,i)},listen:function(n,r){return t.requestEvent(e,n,r)}}},e.prototype.requestPromise=function(e,t,r,i){var o=this;void 0===i&&(i=u.CancellationToken.None);var a=this.lastRequestId++,l={id:a,type:100,channelName:e,name:t,arg:r};if(i.isCancellationRequested)return Promise.reject(c.canceled());var f,h=new Promise(function(e,t){
if(i.isCancellationRequested)return t(c.canceled());var r=s.createCancelablePromise(function(e){return o.whenInitialized()});r.then(function(){r=null;o.handlers.set(a,function(n){switch(n.type){case 201:o.handlers.delete(a),e(n.data);break;case 202:o.handlers.delete(a);var r=new Error(n.data.message);r.stack=n.data.stack,r.name=n.data.name,t(r);break;case 203:o.handlers.delete(a),t(n.data)}}),o.sendRequest(l)});var u=function(){r?(r.cancel(),r=null):o.sendRequest({id:a,type:101}),t(c.canceled())},h=i.onCancellationRequested(u);f=n.combinedDisposable([n.toDisposable(u),h]),o.activeRequests.add(f)});return s.always(h,function(){return o.activeRequests.delete(f)}),h},e.prototype.requestEvent=function(e,t,n){var r=this,i=this.lastRequestId++,u={id:i,type:102,channelName:e,name:t,arg:n},c=null,a=new o.Emitter({onFirstListenerAdd:function(){(c=s.createCancelablePromise(function(e){return r.whenInitialized()})).then(function(){c=null,r.activeRequests.add(a),r.sendRequest(u)})},onLastListenerRemove:function(){
c?(c.cancel(),c=null):(r.activeRequests.delete(a),r.sendRequest({id:i,type:103}))}});return this.handlers.set(i,function(e){return a.fire(e.data)}),a.event},e.prototype.sendRequest=function(e){switch(e.type){case 100:case 102:return this.send([e.type,e.id,e.channelName,e.name],e.arg);case 101:case 103:return this.send([e.type,e.id])}},e.prototype.send=function(e,t){void 0===t&&(t=void 0);var n=new y;f(n,e),f(n,t),this.sendBuffer(n.buffer)},e.prototype.sendBuffer=function(e){try{this.protocol.send(e)}catch(e){}},e.prototype.onBuffer=function(e){var t=new g(e),n=h(t),r=h(t);switch(n[0]){case 200:return this.onResponse({type:n[0]});case 201:case 202:case 204:case 203:return this.onResponse({type:n[0],id:n[1],data:r})}},e.prototype.onResponse=function(e){if(200===e.type)return this.state=d.Idle,void this._onDidInitialize.fire();var t=this.handlers.get(e.id);t&&t(e)},e.prototype.whenInitialized=function(){return this.state===d.Idle?Promise.resolve():o.Event.toPromise(this.onDidInitialize)},
e.prototype.dispose=function(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(function(e){return e.dispose()}),this.activeRequests.clear()},e}();t.ChannelClient=_;var w=function(){function e(e){var t=this;this.channels=new Map,this._connections=new Set,this._onDidChangeConnections=new o.Emitter,this.onDidChangeConnections=this._onDidChangeConnections.event,e(function(e){var n=e.protocol,r=e.onDidClientDisconnect;o.Event.once(n.onMessage)(function(e){var i=h(new g(e)),o=new b(n,i),s=new _(n);t.channels.forEach(function(e,t){return o.registerChannel(t,e)});var u={channelClient:s,ctx:i};t._connections.add(u),t._onDidChangeConnections.fire(u),r(function(){o.dispose(),s.dispose(),t._connections.delete(u)})})})}return Object.defineProperty(e.prototype,"connections",{get:function(){var e=[];return this._connections.forEach(function(t){return e.push(t)}),e},enumerable:!0,configurable:!0}),e.prototype.getChannel=function(e,t){var n=this;return{
call:function(r,i,o){return p(t.routeCall(n,r,i).then(function(t){return t.channelClient.getChannel(e)})).call(r,i,o)},listen:function(r,i){return p(t.routeEvent(n,r,i).then(function(t){return t.channelClient.getChannel(e)})).listen(r,i)}}},e.prototype.registerChannel=function(e,t){this.channels.set(e,t)},e.prototype.dispose=function(){this.channels.clear(),this._connections.clear(),this._onDidChangeConnections.dispose()},e}();t.IPCServer=w;var C=function(){function e(e,t){var n=new y;f(n,t),e.send(n.buffer),this.channelClient=new _(e),this.channelServer=new b(e,t)}return e.prototype.getChannel=function(e){return this.channelClient.getChannel(e)},e.prototype.registerChannel=function(e,t){this.channelServer.registerChannel(e,t)},e.prototype.dispose=function(){this.channelClient.dispose(),this.channelServer.dispose()},e}();t.IPCClient=C,t.getDelayedChannel=p,t.getNextTickChannel=function(e){var t=!1;return{call:function(n,r,i){return t?e.call(n,r,i):s.timeout(0).then(function(){return t=!0}).then(function(){
return e.call(n,r,i)})},listen:function(n,r){if(t)return e.listen(n,r);var i=new o.Relay;return s.timeout(0).then(function(){return t=!0}).then(function(){return i.input=e.listen(n,r)}),i.event}}};var E=function(){function e(e){this.fn=e}return e.prototype.routeCall=function(e){return this.route(e)},e.prototype.routeEvent=function(e){return this.route(e)},e.prototype.route=function(e){return r(this,void 0,void 0,function(){var t,n,r;return i(this,function(i){switch(i.label){case 0:t=0,n=e.connections,i.label=1;case 1:return t<n.length?(r=n[t],[4,Promise.resolve(this.fn(r.ctx))]):[3,4];case 2:if(i.sent())return[2,Promise.resolve(r)];i.label=3;case 3:return t++,[3,1];case 4:return[4,o.Event.toPromise(e.onDidChangeConnections)];case 5:return i.sent(),[4,this.route(e)];case 6:return[2,i.sent()]}})})},e}();t.StaticRouter=E}),define(e[21],t([31,30]),function(e,t){return e.create("vs/base/node/processes",t)}),define(e[24],t([0,1,29,28,27,21,7,8,12,4,18,16]),function(e,t,r,i,o,s,u,c,a,l,f,h){"use strict"
;function p(t,n){if(l.isWindows)try{var r={stdio:["pipe","pipe","ignore"]};n&&(r.cwd=n),o.execFileSync("taskkill",["/T","/F","/PID",t.pid.toString()],r)}catch(e){return{success:!1,error:e,code:e.status?function(e){switch(e){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}(e.status):1}}else if(l.isLinux||l.isMacintosh)try{var i=h.getPathFromAmdModule(e,"vs/base/node/terminateProcess.sh"),s=o.spawnSync(i,[t.pid.toString()]);if(s.error)return{success:!1,error:s.error}}catch(e){return{success:!1,error:e}}else t.kill("SIGKILL");return{success:!0}}function d(){return process.env.comspec||"cmd.exe"}Object.defineProperty(t,"__esModule",{value:!0}),t.terminateProcess=p,t.getWindowsShell=d,t.sanitizeProcessEnvironment=function(e){var t=[/^ELECTRON_.+$/,/^GOOGLE_API_KEY$/,/^VSCODE_.+$/];Object.keys(e).forEach(function(n){for(var r=0;r<t.length;r++)if(-1!==n.search(t[r])){delete e[n];break}})};var v=function(){function e(e,t,n,r){var i=this;if(void 0!==t&&void 0!==n&&void 0!==r)this.cmd=e,this.args=t,
this.shell=n,this.options=r;else{var o=e;this.cmd=o.command,this.shell=o.isShellCommand,this.args=o.args.slice(0),this.options=o.options||{}}if(this.childProcess=null,this.terminateRequested=!1,this.options.env){var s=Object.create(null);Object.keys(process.env).forEach(function(e){s[e]=process.env[e]}),Object.keys(this.options.env).forEach(function(e){s[e]=i.options.env[e]}),this.options.env=s}}return e.prototype.getSanitizedCommand=function(){var t=this.cmd.toLowerCase(),n=t.lastIndexOf(r.sep);return-1!==n&&(t=t.substring(n+1)),e.WellKnowCommands[t]?t:"other"},e.prototype.start=function(e){var t=this;return l.isWindows&&(this.options&&this.options.cwd&&a.isUNC(this.options.cwd)||!this.options&&a.isUNC(process.cwd()))?Promise.reject(new Error(s.localize(0,null))):this.useExec().then(function(n){var r,i,s=new Promise(function(e,t){r=e,i=t});if(n){var a=t.cmd;t.args&&(a=a+" "+t.args.join(" ")),t.childProcess=o.exec(a,t.options,function(n,o,s){t.childProcess=null;var u=n;u&&u.killed?i({
killed:t.terminateRequested,stdout:o.toString(),stderr:s.toString()}):t.handleExec(r,e,n,o,s)})}else{var f=null,h=function(n){t.childProcess=null,t.childProcessPromise=null,t.handleClose(n,r,e,i);var o={terminated:t.terminateRequested};u.isNumber(n)&&(o.cmdCode=n),r(o)};if(t.shell&&l.isWindows){var p=c.deepClone(t.options);p.windowsVerbatimArguments=!0,p.detached=!1;var v=!1,g=!1,y=[],m=t.ensureQuotes(t.cmd);y.push(m.value),v=m.quoted,t.args&&t.args.forEach(function(e){m=t.ensureQuotes(e),y.push(m.value),g=g&&m.quoted});var b=["/s","/c"];v?g?b.push('"'+y.join(" ")+'"'):y.length>1?b.push('"'+y[0]+'" '+y.slice(1).join(" ")):b.push('"'+y[0]+'"'):b.push(y.join(" ")),f=o.spawn(d(),b,p)}else t.cmd&&(f=o.spawn(t.cmd,t.args,t.options));f&&(t.childProcess=f,t.childProcessPromise=Promise.resolve(f),t.pidResolve&&(t.pidResolve(u.isNumber(f.pid)?f.pid:-1),t.pidResolve=void 0),f.on("error",function(e){t.childProcess=null,i({terminated:t.terminateRequested,error:e})}),f.pid&&(t.childProcess.on("close",h),
t.handleSpawn(f,r,e,i,!0)))}return s})},e.prototype.handleClose=function(e,t,n,r){},e.prototype.ensureQuotes=function(t){return e.regexp.test(t)?{value:'"'+t+'"',quoted:!0}:{value:t,quoted:t.length>0&&'"'===t[0]&&'"'===t[t.length-1]}},Object.defineProperty(e.prototype,"pid",{get:function(){var e=this;return this.childProcessPromise?this.childProcessPromise.then(function(e){return e.pid},function(e){return-1}):new Promise(function(t){e.pidResolve=t})},enumerable:!0,configurable:!0}),e.prototype.terminate=function(){var e=this;return this.childProcessPromise?this.childProcessPromise.then(function(t){e.terminateRequested=!0;var n=p(t,e.options.cwd);return n.success&&(e.childProcess=null),n},function(e){return{success:!0}}):Promise.resolve({success:!0})},e.prototype.useExec=function(){var e=this;return new Promise(function(t,n){e.shell&&l.isWindows||t(!1);var r=o.spawn(d(),["/s","/c"]);r.on("error",function(e){t(!0)}),r.on("exit",function(e){t(!1)})})},e.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,
grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},e.regexp=/^[^"].* .*[^"]/,e}();t.AbstractProcess=v;var g=function(e){function t(t,n,r,i){return e.call(this,t,n,r,i)||this}return n(t,e),t.prototype.handleExec=function(e,t,n,r,i){[r,i].forEach(function(e,n){var r=new f.LineDecoder;r.write(e).forEach(function(e){t({line:e,source:0===n?0:1})});var i=r.end();i&&t({line:i,source:0===n?0:1})}),e({terminated:this.terminateRequested,error:n})},t.prototype.handleSpawn=function(e,t,n,r,i){var o=this;this.stdoutLineDecoder=new f.LineDecoder,this.stderrLineDecoder=new f.LineDecoder,e.stdout.on("data",function(e){o.stdoutLineDecoder.write(e).forEach(function(e){return n({line:e,source:0})})}),e.stderr.on("data",function(e){o.stderrLineDecoder.write(e).forEach(function(e){return n({line:e,source:1})})})},t.prototype.handleClose=function(e,t,n,r){[this.stdoutLineDecoder.end(),this.stderrLineDecoder.end()].forEach(function(e,t){e&&n({line:e,
source:0===t?0:1})})},t}(v);t.LineProcess=g,t.createQueuedSender=function(e){var t=[],n=!1,r=function(i){n?t.push(i):e.send(i,function(e){if(e&&console.error(e),n=!1,t.length>0){var i=t.slice(0);t=[],i.forEach(function(e){return r(e)})}})&&!l.isWindows||(n=!0)};return{send:r}};!function(e){e.findExecutable=function(e,t,n){if(r.isAbsolute(e))return e;if(void 0===t&&(t=process.cwd()),"."!==r.dirname(e))return r.join(t,e);if(void 0===n&&u.isString(process.env.PATH)&&(n=process.env.PATH.split(r.delimiter)),void 0===n||0===n.length)return r.join(t,e);for(var o=0,s=n;o<s.length;o++){var c=s[o],a=void 0;if(a=r.isAbsolute(c)?r.join(c,e):r.join(t,c,e),i.existsSync(a))return a;var l=a+".com";if(i.existsSync(l))return l;if(l=a+".exe",i.existsSync(l))return l}return r.join(t,e)}}(t.win32||(t.win32={}))}),define(e[26],t([0,1,27,2,11,8,3,24,20,13,6,5]),function(e,t,r,i,o,s,u,c,a,l,f,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var p=function(e){function t(t){var n=e.call(this,{send:function(e){try{
process.send&&process.send(e.toString("base64"))}catch(e){}},onMessage:u.Event.fromNodeEventEmitter(process,"message",function(e){return Buffer.from(e,"base64")})},t)||this;return process.once("disconnect",function(){return n.dispose()}),n}return n(t,e),t}(a.ChannelServer);t.Server=p;var d=function(){function e(e,t){this.modulePath=e,this.options=t,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new u.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;var n=t&&t.timeout?t.timeout:6e4;this.disposeDelayer=new o.Delayer(n),this.child=null,this._client=null}return e.prototype.getChannel=function(e){var t=this;return{call:function(n,r,i){return t.requestPromise(e,n,r,i)},listen:function(n,r){return t.requestEvent(e,n,r)}}},e.prototype.requestPromise=function(e,t,n,r){var s=this;if(void 0===r&&(r=f.CancellationToken.None),!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(r.isCancellationRequested)return Promise.reject(h.canceled());this.disposeDelayer.cancel()
;var u=this.getCachedChannel(e),c=o.createCancelablePromise(function(e){return u.call(t,n,e)}),a=r.onCancellationRequested(function(){return c.cancel()}),l=i.toDisposable(function(){return c.cancel()});return this.activeRequests.add(l),o.always(c,function(){a.dispose(),s.activeRequests.delete(l),0===s.activeRequests.size&&s.disposeDelayer.trigger(function(){return s.disposeClient()})}),c},e.prototype.requestEvent=function(e,t,n){var r=this;if(!this.disposeDelayer)return u.Event.None;this.disposeDelayer.cancel();var i,o=new u.Emitter({onFirstListenerAdd:function(){var s=r.getCachedChannel(e).listen(t,n);i=s(o.fire,o),r.activeRequests.add(i)},onLastListenerRemove:function(){r.activeRequests.delete(i),i.dispose(),0===r.activeRequests.size&&r.disposeDelayer&&r.disposeDelayer.trigger(function(){return r.disposeClient()})}});return o.event},Object.defineProperty(e.prototype,"client",{get:function(){var e=this;if(!this._client){var t=this.options&&this.options.args?this.options.args:[],n=Object.create(null)
;n.env=s.assign(s.deepClone(process.env),{VSCODE_PARENT_PID:String(process.pid)}),this.options&&this.options.env&&(n.env=s.assign(n.env,this.options.env)),this.options&&this.options.freshExecArgv&&(n.execArgv=[]),this.options&&"number"==typeof this.options.debug&&(n.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&"number"==typeof this.options.debugBrk&&(n.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),this.child=r.fork(this.modulePath,t,n);var o=new u.Emitter;u.Event.fromNodeEventEmitter(this.child,"message",function(e){return e})(function(t){l.isRemoteConsoleLog(t)?l.log(t,"IPC Library: "+e.options.serverName):o.fire(Buffer.from(t,"base64"))});var f=this.options.useQueue?c.createQueuedSender(this.child):this.child,h={send:function(t){return e.child&&e.child.connected&&f.send(t.toString("base64"))},onMessage:o.event};this._client=new a.ChannelClient(h);var p=function(){return e.disposeClient()};process.once("exit",p),this.child.on("error",function(t){
return console.warn('IPC "'+e.options.serverName+'" errored with '+t)}),this.child.on("exit",function(t,n){process.removeListener("exit",p),e.activeRequests.forEach(function(e){return i.dispose(e)}),e.activeRequests.clear(),0!==t&&"SIGTERM"!==n&&console.warn('IPC "'+e.options.serverName+'" crashed with exit code '+t+" and signal "+n),e.disposeDelayer&&e.disposeDelayer.cancel(),e.disposeClient(),e._onDidProcessExit.fire({code:t,signal:n})})}return this._client},enumerable:!0,configurable:!0}),e.prototype.getCachedChannel=function(e){var t=this.channels.get(e);return t||(t=this.client.getChannel(e),this.channels.set(e,t)),t},e.prototype.disposeClient=function(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())},e.prototype.dispose=function(){this._onDidProcessExit.dispose(),this.disposeDelayer.cancel(),this.disposeDelayer=null,this.disposeClient(),this.activeRequests.clear()},e}();t.Client=d}),define(e[25],t([0,1]),function(e,t){"use strict"
;function n(e,t,n,r){t[i.DI_TARGET]===t?t[i.DI_DEPENDENCIES].push({id:e,index:n,optional:r}):(t[i.DI_DEPENDENCIES]=[{id:e,index:n,optional:r}],t[i.DI_TARGET]=t)}function r(e){if(i.serviceIds.has(e))return i.serviceIds.get(e);var t=function(e,r,i){if(3!==arguments.length)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");n(t,e,i,!1)};return t.toString=function(){return e},i.serviceIds.set(e,t),t}Object.defineProperty(t,"__esModule",{value:!0});var i;!function(e){e.serviceIds=new Map,e.DI_TARGET="$di$target",e.DI_DEPENDENCIES="$di$dependencies",e.getServiceDependencies=function(t){return t[e.DI_DEPENDENCIES]||[]}}(i=t._util||(t._util={})),t.IInstantiationService=r("instantiationService"),t.createDecorator=r,t.optional=function(e){return function(t,r,i){if(3!==arguments.length)throw new Error("@optional-decorator can only be used to decorate a parameter");n(e,t,i,!0)}}}),define(e[23],t([0,1,25,2,4,3]),function(e,t,r,i,o,s){"use strict";function u(){return(new Date).toISOString()}
Object.defineProperty(t,"__esModule",{value:!0}),t.ILogService=r.createDecorator("logService");var c;!function(e){e[e.Trace=0]="Trace",e[e.Debug=1]="Debug",e[e.Info=2]="Info",e[e.Warning=3]="Warning",e[e.Error=4]="Error",e[e.Critical=5]="Critical",e[e.Off=6]="Off"}(c=t.LogLevel||(t.LogLevel={})),t.DEFAULT_LOG_LEVEL=c.Info;var a=function(e){function r(){var n=null!==e&&e.apply(this,arguments)||this;return n.level=t.DEFAULT_LOG_LEVEL,n._onDidChangeLogLevel=n._register(new s.Emitter),n.onDidChangeLogLevel=n._onDidChangeLogLevel.event,n}return n(r,e),r.prototype.setLevel=function(e){this.level!==e&&(this.level=e,this._onDidChangeLogLevel.fire(this.level))},r.prototype.getLevel=function(){return this.level},r}(i.Disposable);t.AbstractLogService=a;var l=function(e){function r(n){void 0===n&&(n=t.DEFAULT_LOG_LEVEL);var r=e.call(this)||this;return r.setLevel(n),r.useColors=!o.isWindows,r}return n(r,e),r.prototype.trace=function(e){for(var t=[],n=1;n<arguments.length;n++)t[n-1]=arguments[n]
;this.getLevel()<=c.Trace&&(this.useColors?console.log.apply(console,["[90m[main "+u()+"][0m",e].concat(t)):console.log.apply(console,["[main "+u()+"]",e].concat(t)))},r.prototype.debug=function(e){for(var t=[],n=1;n<arguments.length;n++)t[n-1]=arguments[n];this.getLevel()<=c.Debug&&(this.useColors?console.log.apply(console,["[90m[main "+u()+"][0m",e].concat(t)):console.log.apply(console,["[main "+u()+"]",e].concat(t)))},r.prototype.info=function(e){for(var t=[],n=1;n<arguments.length;n++)t[n-1]=arguments[n];this.getLevel()<=c.Info&&(this.useColors?console.log.apply(console,["[90m[main "+u()+"][0m",e].concat(t)):console.log.apply(console,["[main "+u()+"]",e].concat(t)))},r.prototype.warn=function(e){for(var t=[],n=1;n<arguments.length;n++)t[n-1]=arguments[n];this.getLevel()<=c.Warning&&(this.useColors?console.warn.apply(console,["[93m[main "+u()+"][0m",e].concat(t)):console.warn.apply(console,["[main "+u()+"]",e].concat(t)))},r.prototype.error=function(e){
for(var t=[],n=1;n<arguments.length;n++)t[n-1]=arguments[n];this.getLevel()<=c.Error&&(this.useColors?console.error.apply(console,["[91m[main "+u()+"][0m",e].concat(t)):console.error.apply(console,["[main "+u()+"]",e].concat(t)))},r.prototype.critical=function(e){for(var t=[],n=1;n<arguments.length;n++)t[n-1]=arguments[n];this.getLevel()<=c.Critical&&(this.useColors?console.error.apply(console,["[90m[main "+u()+"][0m",e].concat(t)):console.error.apply(console,["[main "+u()+"]",e].concat(t)))},r.prototype.dispose=function(){},r}(a);t.ConsoleLogMainService=l;var f=function(e){function r(n){void 0===n&&(n=t.DEFAULT_LOG_LEVEL);var r=e.call(this)||this;return r.setLevel(n),r}return n(r,e),r.prototype.trace=function(e){for(var t=[],n=1;n<arguments.length;n++)t[n-1]=arguments[n];this.getLevel()<=c.Trace&&console.log.apply(console,["%cTRACE","color: #888",e].concat(t))},r.prototype.debug=function(e){for(var t=[],n=1;n<arguments.length;n++)t[n-1]=arguments[n]
;this.getLevel()<=c.Debug&&console.log.apply(console,["%cDEBUG","background: #eee; color: #888",e].concat(t))},r.prototype.info=function(e){for(var t=[],n=1;n<arguments.length;n++)t[n-1]=arguments[n];this.getLevel()<=c.Info&&console.log.apply(console,["%c INFO","color: #33f",e].concat(t))},r.prototype.warn=function(e){for(var t=[],n=1;n<arguments.length;n++)t[n-1]=arguments[n];this.getLevel()<=c.Warning&&console.log.apply(console,["%c WARN","color: #993",e].concat(t))},r.prototype.error=function(e){for(var t=[],n=1;n<arguments.length;n++)t[n-1]=arguments[n];this.getLevel()<=c.Error&&console.log.apply(console,["%c  ERR","color: #f33",e].concat(t))},r.prototype.critical=function(e){for(var t=[],n=1;n<arguments.length;n++)t[n-1]=arguments[n];this.getLevel()<=c.Critical&&console.log.apply(console,["%cCRITI","background: #f33; color: white",e].concat(t))},r.prototype.dispose=function(){},r}(a);t.ConsoleLogService=f;var h=function(e){function t(t){var n=e.call(this)||this;return n.logServices=t,
t.length&&n.setLevel(t[0].getLevel()),n}return n(t,e),t.prototype.setLevel=function(t){for(var n=0,r=this.logServices;n<r.length;n++){r[n].setLevel(t)}e.prototype.setLevel.call(this,t)},t.prototype.trace=function(e){for(var t=[],n=1;n<arguments.length;n++)t[n-1]=arguments[n];for(var r=0,i=this.logServices;r<i.length;r++){var o=i[r];o.trace.apply(o,[e].concat(t))}},t.prototype.debug=function(e){for(var t=[],n=1;n<arguments.length;n++)t[n-1]=arguments[n];for(var r=0,i=this.logServices;r<i.length;r++){var o=i[r];o.debug.apply(o,[e].concat(t))}},t.prototype.info=function(e){for(var t=[],n=1;n<arguments.length;n++)t[n-1]=arguments[n];for(var r=0,i=this.logServices;r<i.length;r++){var o=i[r];o.info.apply(o,[e].concat(t))}},t.prototype.warn=function(e){for(var t=[],n=1;n<arguments.length;n++)t[n-1]=arguments[n];for(var r=0,i=this.logServices;r<i.length;r++){var o=i[r];o.warn.apply(o,[e].concat(t))}},t.prototype.error=function(e){for(var t=[],n=1;n<arguments.length;n++)t[n-1]=arguments[n]
;for(var r=0,i=this.logServices;r<i.length;r++){var o=i[r];o.error.apply(o,[e].concat(t))}},t.prototype.critical=function(e){for(var t=[],n=1;n<arguments.length;n++)t[n-1]=arguments[n];for(var r=0,i=this.logServices;r<i.length;r++){var o=i[r];o.critical.apply(o,[e].concat(t))}},t.prototype.dispose=function(){for(var e=0,t=this.logServices;e<t.length;e++){t[e].dispose()}},t}(a);t.MultiplexLogService=h;var p=function(e){function t(t){var n=e.call(this)||this;return n.logService=t,n._register(t),n}return n(t,e),Object.defineProperty(t.prototype,"onDidChangeLogLevel",{get:function(){return this.logService.onDidChangeLogLevel},enumerable:!0,configurable:!0}),t.prototype.setLevel=function(e){this.logService.setLevel(e)},t.prototype.getLevel=function(){return this.logService.getLevel()},t.prototype.trace=function(e){for(var t=[],n=1;n<arguments.length;n++)t[n-1]=arguments[n];var r;(r=this.logService).trace.apply(r,[e].concat(t))},t.prototype.debug=function(e){
for(var t=[],n=1;n<arguments.length;n++)t[n-1]=arguments[n];var r;(r=this.logService).debug.apply(r,[e].concat(t))},t.prototype.info=function(e){for(var t=[],n=1;n<arguments.length;n++)t[n-1]=arguments[n];var r;(r=this.logService).info.apply(r,[e].concat(t))},t.prototype.warn=function(e){for(var t=[],n=1;n<arguments.length;n++)t[n-1]=arguments[n];var r;(r=this.logService).warn.apply(r,[e].concat(t))},t.prototype.error=function(e){for(var t=[],n=1;n<arguments.length;n++)t[n-1]=arguments[n];var r;(r=this.logService).error.apply(r,[e].concat(t))},t.prototype.critical=function(e){for(var t=[],n=1;n<arguments.length;n++)t[n-1]=arguments[n];var r;(r=this.logService).critical.apply(r,[e].concat(t))},t}(i.Disposable);t.DelegatedLogService=p;var d=function(){function e(){this.onDidChangeLogLevel=(new s.Emitter).event}return e.prototype.setLevel=function(e){},e.prototype.getLevel=function(){return c.Info},e.prototype.trace=function(e){for(var t=[],n=1;n<arguments.length;n++)t[n-1]=arguments[n]},
e.prototype.debug=function(e){for(var t=[],n=1;n<arguments.length;n++)t[n-1]=arguments[n]},e.prototype.info=function(e){for(var t=[],n=1;n<arguments.length;n++)t[n-1]=arguments[n]},e.prototype.warn=function(e){for(var t=[],n=1;n<arguments.length;n++)t[n-1]=arguments[n]},e.prototype.error=function(e){for(var t=[],n=1;n<arguments.length;n++)t[n-1]=arguments[n]},e.prototype.critical=function(e){for(var t=[],n=1;n<arguments.length;n++)t[n-1]=arguments[n]},e.prototype.dispose=function(){},e}();t.NullLogService=d,t.getLogLevel=function(e){if(e.verbose)return c.Trace;if("string"==typeof e.args.log)switch(e.args.log.toLowerCase()){case"trace":return c.Trace;case"debug":return c.Debug;case"info":return c.Info;case"warn":return c.Warning;case"error":return c.Error;case"critical":return c.Critical;case"off":return c.Off}return t.DEFAULT_LOG_LEVEL}});var o=this&&this.__decorate||function(e,t,n,r){var i,o=arguments.length,s=o<3?t:null===r?r=Object.getOwnPropertyDescriptor(t,n):r
;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)s=Reflect.decorate(e,t,n,r);else for(var u=e.length-1;u>=0;u--)(i=e[u])&&(s=(o<3?i(s):o>3?i(t,n,s):i(t,n))||s);return o>3&&s&&Object.defineProperty(t,n,s),s},s=this&&this.__param||function(e,t){return function(n,r){t(n,r,e)}};define(e[22],t([0,1,32,7,8,23]),function(e,t,n,r,i,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var c=function(){function e(e,t,r,i){this._eventPrefix=e,this._defaultData=t,this._logService=i,this._defaultData||(this._defaultData=Object.create(null)),"string"==typeof r?this._aiClient=function(e){var t;return n.defaultClient?(t=new n.TelemetryClient(e)).channel.setUseDiskRetryCaching(!0):(n.setup(e).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),t=n.defaultClient),
0===e.indexOf("AIF-")&&(t.config.endpointUrl="https://vortex.data.microsoft.com/collect/v1"),t}(r):"function"==typeof r&&(this._aiClient=r())}return e._getData=function(t){var n=Object.create(null),r=Object.create(null),i=Object.create(null);e._flaten(t,i);for(var o in i){var s=i[o=o.length>150?o.substr(o.length-149):o];"number"==typeof s?r[o]=s:"boolean"==typeof s?r[o]=s?1:0:"string"==typeof s?n[o]=s.substring(0,1023):void 0!==s&&null!==s&&(n[o]=s)}return{properties:n,measurements:r}},e._flaten=function(t,n,o,s){if(void 0===o&&(o=0),t)for(var u=0,c=Object.getOwnPropertyNames(t);u<c.length;u++){var a=c[u],l=t[a],f=s?s+a:a;Array.isArray(l)?n[f]=i.safeStringify(l):l instanceof Date?n[f]=l.toISOString():r.isObject(l)?o<2?e._flaten(l,n,o+1,f+"."):n[f]=i.safeStringify(l):n[f]=l}},e.prototype.log=function(t,n){this._aiClient&&(n=i.mixin(n,this._defaultData),n=e._getData(n),this._logService&&this._logService.trace("telemetry/"+t,n),this._aiClient.trackEvent({name:this._eventPrefix+"/"+t,properties:n.properties,
measurements:n.measurements}))},e.prototype.dispose=function(){var e=this;if(this._aiClient)return new Promise(function(t){e._aiClient.flush({callback:function(){e._aiClient=void 0,t(void 0)}})})},e=o([s(3,u.ILogService)],e)}();t.AppInsightsAppender=c}),define(e[19],t([0,1]),function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var n=function(){function e(e){this.appender=e}return e.prototype.listen=function(e,t){throw new Error("Event not found: "+t)},e.prototype.call=function(e,t,n){var r=n.eventName,i=n.data;return this.appender.log(r,i),Promise.resolve(null)},e}();t.TelemetryAppenderChannel=n;var r=function(){function e(e){this.channel=e}return e.prototype.log=function(e,t){return this.channel.call("log",{eventName:e,data:t}).then(void 0,function(e){return"Failed to log telemetry: "+console.warn(e)}),Promise.resolve(null)},e.prototype.dispose=function(){},e}();t.TelemetryAppenderClient=r}),define(e[34],t([0,1,26,22,19]),function(e,t,n,r,i){"use strict"
;Object.defineProperty(t,"__esModule",{value:!0});var o=new r.AppInsightsAppender(process.argv[2],JSON.parse(process.argv[3]),process.argv[4]);process.once("exit",function(){return o.dispose()});var s=new i.TelemetryAppenderChannel(o);new n.Server("telemetry").registerChannel("telemetryAppender",s)})}).call(this);
//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/7c66f58312b48ed8ca4e387ebd9ffe9605332caa/core/vs\workbench\parts\debug\node\telemetryApp.js.map
